class AssignTaskByGroupController < ApplicationController
   before_action :require_login
   before_action :allowed_pages
   before_action :is_allowed_location
   skip_before_action :verify_authenticity_token,:only=>[:index,:sitesearch]
   include ErpModule::Common
   helper_method :currency_formatted,:year_month_days_formatted,:formatted_date,:set_ent,:set_dct,:get_selected_user_detail
   helper_method :find_batch_task_detail,:find_batch_task_category,:get_employee_detail,:get_site_names
 def index
       @compcodes    = session[:loggedUserCompCode]
       @tseach       = ''
       @LevelHead    = nil
       @batchtask    = MstBatchTaskList.where("bt_compcode = ? ",@compcodes).order("bt_name ASC")
       @batchCateg   = MstBatchTaskCategory.where("btc_compcode = ? ",@compcodes).order("btc_name ASC")
        @mstXEmpEdit = User.where("usercompcode = ?",@compcodes).order("firstname ASC")
       @batchdetail  = [] #search_group_item
       @cdated       = formatted_date(Time.now)
       if params[:id].to_i >0
            @LevelHead  = TrnBatchTaskAssign.where("bts_compcode = ? AND id= ?",@compcodes,params[:id].to_i).first
       end

end

def create
  @compcodes = session[:loggedUserCompCode]
  isFlags   = true
  begin
  if params[:bts_batchtask] == '' || params[:bts_batchtask]== nil
         flash[:error] =  "Please select batch task"
         isFlags       =  false 
  elsif params[:bts_assigndate] == '' || params[:bts_assigndate] == nil
         flash[:error] =  "Please enter start date."
         isFlags       =  false
 # elsif params[:bts_assignto] == '' || params[:bts_assignto] == nil
 #        flash[:error] =  "Please select assign to"
 #        isFlags       =  false
   elsif @compcodes == ''  || @compcodes == nil
         flash[:error] =  "Invalid company!"
         isFlags       =  false
   else

          mid          = params[:mid].to_i >0 ? params[:mid] : 0
          batchtask    = params[:bts_batchtask].to_i >0 ? params[:bts_batchtask] : 0
          batchcats    = params[:bts_taskcat].to_i >0 ? params[:bts_taskcat] : 0
          assigndate   = params[:bts_assigndate] != nil && params[:bts_assigndate] != '' ? year_month_days_formatted(params[:bts_assigndate]) : 0
          assignto     = params[:bts_assignto].to_i >0 ? params[:bts_assignto] : 0
          sitenumber   = params[:bts_siteno] != nil && params[:bts_siteno] != ''  ? params[:bts_siteno] : ''
          targetdated  = 0
         if isFlags
                 batchproces =    check_already_assigned_task(sitenumber,assignto,batchtask)
                 if batchproces.length >0
                    flash[:error] =  "This site is already assigned to selected assign employee."
                    isFlags       =  false
                 else
                        objlevel =    MstBatchTaskDetail.where("btd_compcode = ? AND btd_batchtask = ?",@compcodes,batchtask)
                        if objlevel.length >0
                            objlevel.each do |newasssbatch|
                               assign_batch_task_detai(newasssbatch.btd_compcode,newasssbatch.btd_batchtask,newasssbatch.btd_taskcat,newasssbatch.btd_description,newasssbatch.btd_nodays,assigndate,assignto,mid,sitenumber,targetdated)
                            end
                               flash[:error] =  "Batch task assigned Successfully."
                               isFlags       =  true
                        else
                               flash[:error] =  "Could not be assign due to mismatch batch task or batch category."
                               isFlags       =  false
                        end
                 end
          end

   end

  rescue Exception => exc
      flash[:error]            = "#{exc.message}"
      session[:isErrorhandled] = 1
      isFlags                  = false
   end

   if !isFlags
     session[:request_params] = params
     session[:isErrorhandled] = 1
     isFlags                  = false
   else
     session[:request_params] = nil
     session[:isErrorhandled] = nil
     session.delete(:request_params)
   end
    redirect_to "#{root_url}"+"assign_task_by_group"
end


def assign_task_by_group_refresh
 session[:request_params] = nil
 session.delete(:request_params)
 session[:req_groupsrch] = nil
 redirect_to "#{root_url}"+"assign_task_by_group"
end


def show
   @compcodes  = session[:loggedUserCompCode]

end


 def destroy
 customerid     =  params[:id].to_i
 @compcodes     =  session[:loggedUserCompCode]
 @customerId    =  customerid
 #check_customer_group_exist
 #if @isDelFlags
 #      flash[:error] =  "Sorry!! Unable to deletion!"
 #      session[:isErrorhandled] = 1
# else
     leveldelobj =  TrnBatchTaskAssign.where("bts_compcode = ? AND id = ? ",@compcodes,customerid).first
     if leveldelobj
        leveldelobj.destroy
        flash[:error]            =  "Data deleted successfully!"
        session[:isErrorhandled] = nil
      end
 #end
  redirect_to "#{root_url}"+"assign_task_by_group"
end

 private
 def check_already_assigned_task(sitno,assign,batchtask)
   assignedobj =  TrnMultiAssign.where("ms_compcode = ? AND ms_assignuser = ? AND ms_projectsite = ? AND ms_batchtask = ?",@compcodes,assign,sitno,batchtask)
   # assignedobj = TrnBatchTaskAssign.where("bts_compcode = ? AND bts_siteno = ? AND bts_assignto = ? AND bts_batchtask = ?",@compcodes,sitno,assign,batchtask)
   return assignedobj
 end

private
def search_group_item
    if params[:page].to_i >0
      pages = params[:page]
    else
       pages = 1
    end
    groupsearch   =  params[:group_search]!='' &&  params[:group_search]!=nil ? params[:group_search] : session[:req_groupsrch]
    iswhere       = "bts_compcode ='#{@compcodes}' AND bts_type='A'"
   if groupsearch!='' &&  groupsearch!=nil
       isgdname       = "%"+groupsearch+"%"
       @tseach        = groupsearch
       session[:req_groupsrch] = groupsearch
       iswhere   += " AND bts_batchtask LIKE '#{isgdname}' OR bts_taskcat LIKE '#{isgdname}'"
   end
   batstaskobj = TrnBatchTaskAssign.where(iswhere).paginate(:page =>pages,:per_page => 20).order('id DESC')
   return batstaskobj
end

private
def assign_batch_task_detai(bts_compcode,bts_batchtask,bts_taskcat,bts_description,bts_nodays,bts_assigndate,bts_assignto,mid,sitenumber,targetdated)
  bts_assignby    = session[:autherizedUserId]
  bts_description = bts_description !=nil && bts_description!= '' ? bts_description : ''
  bts_nodays      = bts_nodays !=nil && bts_nodays !='' ? bts_nodays : 0
  astargetdt      = 0
  if bts_nodays!=nil &&  bts_nodays!=''
       if bts_assigndate != nil && bts_assigndate !=''
            if bts_nodays.to_f >0             
               newdated   = Date.parse(bts_assigndate.to_s)+bts_nodays.to_i
            else
               btsnodays = (-1)*bts_nodays
               newdated   = Date.parse(bts_assigndate.to_s)-btsnodays.to_i
            end            
            astargetdt = year_month_days_formatted(newdated)
       end
  end
 

  bts_assignto = 0
  bachupd      = TrnBatchTaskAssign.where("bts_compcode = ? AND id = ?",bts_compcode,mid).first
  if bachupd
       bachupd.update(:bts_batchtask=>bts_batchtask,:bts_tragetdate=>astargetdt,:bts_type=>'A',:bts_taskcat=>bts_taskcat,:bts_nodays=>bts_nodays,:bts_description=>bts_description,:bts_assigndate=>astargetdt,:bts_assignto=>bts_assignto,:bts_siteno=>sitenumber)
      
  else
       batchobj =  TrnBatchTaskAssign.new(:bts_compcode=>bts_compcode,:bts_assignby=>bts_assignby,:bts_tragetdate=>astargetdt,:bts_type=>'A',:bts_batchtask=>bts_batchtask,:bts_taskcat=>bts_taskcat,:bts_nodays=>bts_nodays,:bts_description=>bts_description,:bts_assigndate=>astargetdt,:bts_assignto=>bts_assignto,:bts_siteno=>sitenumber)
       if batchobj.save          
          ### EXECUTE BATCH DETAIL
       end
  end

  ##### PROCESS MULTI ASSIGN TASK USER #####
    k = 1
   if params[:assigntask] !=nil  &&  params[:assigntask] != ''
        params[:assigntask].each do |newtask|
              if params[:assigntask][k] != nil && params[:assigntask][k] != ''
                 assigntask = params[:assigntask][k]
              else
                 assigntask = 0
              end
              if assigntask.to_i >0
                 process_multi_assign_users(bts_compcode,assigntask,sitenumber,bts_batchtask)
              end
              k +=1
        end

    end

  #### END MULTI ASSIGN USER #########

  
end

private
def process_multi_assign_users(compcode,assignuser,siteproject,batch)
      msobj =  TrnMultiAssign.where("ms_compcode = ? AND ms_assignuser = ? AND ms_projectsite = ? AND ms_batchtask = ?",compcode,assignuser,siteproject,batch).first
      if msobj
         ## EXECUTE IF MESSAGE REQUIRED
      else
          mssaveobj = TrnMultiAssign.new(:ms_compcode=>compcode,:ms_assignuser=>assignuser,:ms_projectsite=>siteproject,:ms_batchtask=>batch)
          if mssaveobj.save
            ### EXECUTE IF ANY MESSAGE REQUIRED
          end
      end
end


end



