class ExportInvoiceController < ApplicationController
   before_action :require_login
   before_action :allowed_pages
   before_action :is_allowed_location
   skip_before_action :verify_authenticity_token,:only=> [:ajax_process]
   include ErpModule::Common
   helper_method :currency_formatted,:render_helper_html

  def index
    @compcodes            =  session[:loggedUserCompCode]
    @logedId              =  session[:autherizedUserId]
    @xLoc                 =  session[:autherizedLoc]
    @isFlags              =  false
    @cdate                =  Time.now.strftime('%d-%b-%Y')
    params[:hd_sale_type] = 'S'
    params[:hd_type]      = 'Local'
    @Mstdepart            =  MstPaymentTerm.all.order("TRIM(pts_description) ASC")
    @compObj              =  MstCompany.select("cmp_companycode,cmp_companyname").all.order('cmp_companyname ASC')
    @myCurrency           =  MstCurrency.where(["cc_compcode = ?", @compcodes]).order("TRIM(cc_name)")
    month_number          =  Time.now.month
    month_begin           =  Date.new(Date.today.year, month_number)
    begdate               =  Date.parse(month_begin.to_s)
    @nbegindate           =  begdate.strftime('%d-%b-%Y')
    month_ending          =  month_begin.end_of_month
    endingDate            =  Date.parse(month_ending.to_s)
    @enddate              =  endingDate.strftime('%d-%b-%Y')
    @LastOABills          =  get_orderno_details
    @LastPackNo           =  get_last_pack_number
    @AllPackList          =  get_packlist_all_bills
    @HeadPack             =  nil
    @FootPack             =  nil
    @Customer             =  nil
    @printpath            =  nil
    @rootUrl              =  "#{root_url}"
    @PackingItem          = nil
    @oaNumber             = nil
    @Isonanumber          = nil
    @isPackLstNo          = nil
    ################### PROCESS PACK LISTING Settings################
     if params[:id]!=nil && params[:id]!=''
         dparmes  = params[:id].split("_")
        if dparmes[1]!='PLC' && dparmes[1]!='PCK'
          nlid      = Base64.decode64(params[:id])
          prntid    = params[:id]
          plid      = nlid.split("_")
          pnnumber  = plid[0]
          comxcode  = plid[1]
          typecode  = plid[2]
          
          @HeadPack = TrnPackingInvoice.where("pli_compcode=? AND pli_number=? AND pli_local_type=?",comxcode,pnnumber,typecode).first
          oanumber  = @HeadPack.pli_oa_number
          packingno = @HeadPack.pli_packlist_no
          iscutomer = @HeadPack.pli_invoice_to_id
          @FootPack = TrnPackingInvoiceDetail.where("pldi_compcode=? AND pldi_number=? AND pldi_locality_type=?",comxcode,pnnumber,typecode)
          @Customer = TrnProformaHdr.select("hd_invoiceto,hd_dispmode,hd_billnumber").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_type=? AND hd_billnumber=?", comxcode,params[:hd_sale_type],typecode,oanumber]).first
          @Isonanumber =  TrnProformaHdr.select("hd_invoiceto,hd_dispmode,hd_billnumber").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_type=? AND hd_customer_id=?", comxcode,params[:hd_sale_type],typecode,iscutomer])
        session[:isprintableid] = prntid
          printcontroll        = pnnumber.to_s+"_PLC_"+pnnumber.to_s+"_invoice_report"
          @printpath           = export_invoice_path(printcontroll,:format=>"pdf")
          params[:comp_codes]  = comxcode
          params[:oa_nos]      = oanumber
          params[:hd_type]     = typecode
          @oaNumber            = oanumber
          @LastOABills         = get_orderno_details
          @isPacklist          = get_all_packlist_against_epsno()
          @isPackLstNo         = Base64.encode64(packingno.to_s+"_"+comxcode.to_s+"_"+oanumber.to_s+"_"+typecode.to_s)
        end
        
        
        
        if dparmes[1]=='PLC'
          nlid      = Base64.decode64(session[:isprintableid])
          plid      = nlid.split("_")
          pnnumber  = plid[0]
          comxcode  = plid[1]
          typecode  = plid[2]
          @compDetail   = MstCompany.where(["cmp_companycode = ?", @compcodes]).first
          @HeadPack     = TrnPackingInvoice.where("pli_compcode=? AND pli_number=? AND pli_local_type=?",comxcode,pnnumber,typecode).first
          oanumber      = @HeadPack.pli_oa_number
          customerid    = @HeadPack.pli_invoice_to_id
          @FootPack     = TrnPackingInvoiceDetail.where("pldi_compcode=? AND pldi_number=? AND pldi_locality_type=?",comxcode,pnnumber,typecode)
          @buyers       = TrnProformaHdr.select("hd_invoiceto,hd_dispmode,hd_billnumber,hd_billdate").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_type=? AND hd_billnumber=?", comxcode,params[:hd_sale_type],typecode,oanumber]).first
          @newCustomer  = MstCustomer.where("cs_compcode = ? AND id=?",@compcodes,customerid).first
             if @FootPack.length >0
                 if session[:packlist_print]!=nil && session[:packlist_print]!='' && session[:packlist_print] == 'Y'
                  respond_to do |format|
                    format.html
                      format.pdf do
                          pdf = PackinglistPdf.new(@FootPack,@HeadPack,@newCustomer,@compDetail,@buyers,@rootUrl,'','',session,'','')
                          send_data pdf.render,:filename => "1_"+pnnumber.to_s+"_packing_invoice.pdf", :type => "application/pdf", :disposition => "inline"
                      end
                   end
                 else
                    respond_to do |format|
                    format.html
                        format.pdf do
                            pdf = PackinginvoicePdf.new(@FootPack,@HeadPack,@newCustomer,@compDetail,@buyers,@rootUrl,'','',session,'','')
                            send_data pdf.render,:filename => "1_"+pnnumber.to_s+"_packing_invoice.pdf", :type => "application/pdf", :disposition => "inline"
                        end
                     end

                 end

             end
        end

      end
    ####################################
    common_action_rules_sets()
    session[:generatecustid] = nil
    session[:generateshipid] = nil

end
def create
   @compcodes  =  session[:loggedUserCompCode]
   @logedId    =  session[:autherizedUserId]
   comp_codes  =  params[:hd_company]!=nil && params[:hd_company]!='' ? params[:hd_company] : @compcodes
   comp_type   =  params[:hd_type]!=nil && params[:hd_type]!='' ? params[:hd_type] :'Local'
   isFlags     =  true
   begin
   if params[:hd_company]=='' || params[:hd_company]==nil
          flash[:error] =  "Please select company"
          isFlags       =  false
    elsif params[:hd_type]=='' || params[:hd_type]==nil
          flash[:error] =  "Please select type"
          isFlags       =  false
    elsif params[:pli_number]=='' || params[:pli_number]==nil
          flash[:error] =  "invoice number is required"
          isFlags       =  false
    elsif params[:pli_date]=='' || params[:pli_date]==nil
          flash[:error] =  "Please enter invoice date"
          isFlags       =  false
    elsif params[:hd_invoiceto]=='' || params[:hd_invoiceto]==nil
          flash[:error] =  "Please enter customer name"
          isFlags       =  false
    elsif params[:pli_oa_number]=='' || params[:pli_oa_number]==nil
          flash[:error] =  "Please select OA/EPS No"
          isFlags       =  false
    elsif params[:pli_packlist_no]=='' || params[:pli_packlist_no]==nil
          flash[:error] =  "Please select packing list No"
          isFlags       =  false
    else
        headermid   =  params[:headerid]!=nil && params[:headerid]!='' ? params[:headerid].delete(' ') : 0
        plnumber    =  params[:pli_number]!=nil && params[:pli_number]!='' ? params[:pli_number].delete(' ') : 0
        if isFlags
          packobj = TrnPackingInvoice.where("pli_compcode=? AND pli_number=? AND pli_local_type=?",comp_codes,plnumber,comp_type)
          if packobj.length >0
              upobj  = TrnPackingInvoice.where("pli_compcode=? AND id=?",comp_codes,headermid).first
              if upobj
                   upobj.update(save_pack_listing)
                   process_grid_data(plnumber)
                   flash[:error] = "Data updated successfully."
                   isFlags       = true
              end
          else

              pobj =  TrnPackingInvoice.new(save_pack_listing)
              if params[:isprocessedupdated]!=nil && params[:isprocessedupdated]!='' && params[:isprocessedupdated]=='Y' && params[:pli_number].to_i >0
                  pld_number = params[:pl_number]
                else
                  pld_number  = @sumOfCode
                end
              if pobj.save
                  process_grid_data(pld_number)
                  flash[:error] = "Data saved successfully."
                  isFlags       = true
              end
          end


        end
   end
   if !isFlags
     session[:isErrorhandled] = 1
   else
     session[:postedpamams]   = nil
     session[:isErrorhandled] = nil
     session.delete(:postedpamams)
   end
   rescue Exception => exc
      flash[:error]              = "#{exc.message}"
      session[:isErrorhandled]   = 1
      session[:canceldeletebill] = dt_billnumber = params[:pli_number]
      if params[:isprocessedupdated]!=nil && params[:isprocessedupdated]!='' && params[:isprocessedupdated]!='Y'
        rollback_billing_if_not_acl(dt_billnumber)
      end
   end
   redirect_to "#{root_url}"+"export_invoice"
end

def show
  @compcodes    = session[:loggedUserCompCode]
  @rootUrl      = "#{root_url}"

end

def ajax_process
  @compcodes = session[:loggedUserCompCode]
  if params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='TRNLP'
     get_last_order_details()
     return
  elsif params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='CUSTOMER'
     get_customer_details()
     return
  elsif params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='OAN'
     get_search_prdname_by_oano()
     return
  elsif params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='PACKNO'
     get_process_packno_byorder()
     return
  elsif params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='PRNTPACK'
     print_packlistpath()
     return
  elsif params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='OANOM'
      get_billed_order_detail()
     return
  elsif params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='PRINTINV'
      helper_print_formatted_invoivce()
     return
  end


end

def export_invoice_refresh
 session[:postedpamams]    = nil
 session[:isErrorhandled]  = nil
 session[:hd_billdate]     = nil
 session[:hd_invoiceto]    = nil
 session[:hd_customer_id]  = nil
 session[:hd_refnumber]    = nil
 session[:hd_refnumber]    = nil
 session.delete(:isErrorhandled)
 session.delete(:postedpamams)
 redirect_to "#{root_url}"+"export_invoice"
end

private
def get_orderno_details
  comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
  if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
     if comp_codes == nil ||  comp_codes == ''
       comp_codes = @compcodes
     end
  end
 objitem =  TrnProformaHdr.select("hd_billnumber").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_loc = ? AND hd_type=?", comp_codes,params[:hd_sale_type].to_s,@isLoc.to_s,params[:hd_type]]).order('hd_billnumber desc')
 return objitem
end

private
def get_last_pack_number
  comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
  if comp_codes == nil ||  comp_codes == ''
       comp_codes = @compcodes
  end
  @isCode    = 0
  @Startx    = '0000'
  @recCodes  = TrnPackingInvoice.where(["pli_compcode = ? AND pli_number >0 AND pli_local_type=?", comp_codes,params[:hd_type]]).order('pli_number DESC').first
  if @recCodes
   @isCode  = @recCodes.pli_number.to_i
  end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_i < 10
      @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
      @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
      @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
      @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >5
      @sumXOfCode =  @sumXOfCode.to_i
    end
end
private
def helper_print_formatted_invoivce
     xcomp    = params[:compname]!=nil && params[:compname]!='' ? params[:compname] : ''
     splnum   = params[:plnum]!=nil && params[:plnum]!='' ? params[:plnum] : ''
     oanums   = params[:oanums]!=nil && params[:oanums]!='' ? params[:oanums] : ''
     xtyp     = params[:xtype]!=nil && params[:xtype]!='' ? params[:xtype] : ''
     sltype   = params[:hd_sale_type]!=nil && params[:hd_sale_type]!='' ? params[:hd_sale_type] : 'S'
     @oaNumber            = oanums
     params[:comp_codes]  = xcomp
     params[:oa_nos]      = oanums
     params[:hd_type]     = xtyp
     isstatus             = false
     plnums               = Base64.decode64(splnum)
     npls                 = plnums.split('_')
     plnum                = npls[0]
     #@isPacklist   = get_all_packlist_against_epsno()     
     pckingitems = get_packing_number_details(xcomp,plnum,oanums,xtyp)
     totpcs = 0
     tboxs  = 0
     tntwt  = 0
     tgrswt = 0
     if pckingitems.length >0
         totpcs = pckingitems[0].pl_totno_pices
         tboxs  = pckingitems[0].pl_totno_boxno
         tntwt  = pckingitems[0].pl_tot_netweight
         tgrswt = pckingitems[0].pl_tot_grossweight
         isstatus = true
         newhtml  = render_helper_html(pckingitems)
     end        
    respond_to do |format|
      format.json { render :json => {'pcdata'=>newhtml,'totpcs'=>totpcs,'tboxs'=>tboxs,'tntwt'=>tntwt,'tgrswt'=>tgrswt,:status=>isstatus } }
    end
    
end

private
def print_packlistpath
  isstatus  = false
  session[:packlist_print] = nil
  ischecked  = params[:ischecked]!='' && params[:ischecked]!=nil ? params[:ischecked] : ''
  if ischecked =='Y'
    session[:packlist_print] = 'Y'
    isstatus = true
  else
    session[:packlist_print] = nil
    isstatus = true
  end
  respond_to do |format|
    format.json { render :json => { :status=>isstatus } }
  end
end

private
def get_last_order_details
   compname               = params[:compname]!='' && params[:compname]!=nil ? params[:compname] : ''
   xtype                  = params[:xtype]!='' && params[:xtype]!=nil ? params[:xtype] : ''
   params[:hd_type]       = xtype
   params[:hd_sale_type]  = 'S'
   params[:comp_codes]    = compname
   isstatus               = false;
   get_last_pack_number
   alloano     = ''
   allpackno   = get_all_packlist_against_epsno()
   allob       = []
   lastbillno  = ''

   if @sumXOfCode
       lastbillno = @sumXOfCode
       isstatus   = true
       allob     =  get_packlist_all_number()
   end

  respond_to do |format|
    format.json { render :json => { 'data'=>allob,"allpackno"=>allpackno,"lastbillno"=>lastbillno,"alloano"=>alloano,"message"=>'',:status=>isstatus } }
  end

end

private
def get_billed_order_detail
   compname               = params[:compname]!='' && params[:compname]!=nil ? params[:compname] : ''
   xtype                  = params[:xtype]!='' && params[:xtype]!=nil ? params[:xtype] : ''
   params[:hd_type]       = xtype
   params[:hd_sale_type]  = 'S'
   params[:comp_codes]    = compname
   isstatus               = false;   
   alloano                = get_proforma_all_bills()
   respond_to do |format|
    format.json { render :json => { "alloano"=>alloano,"message"=>'',:status=>isstatus } }
  end

end


private
def get_process_packno_byorder
   compname               = params[:compname]!='' && params[:compname]!=nil ? params[:compname] : ''
   xtype                  = params[:xtype]!='' && params[:xtype]!=nil ? params[:xtype] : ''
   params[:hd_type]       = xtype
   params[:hd_sale_type]  = 'S'
   params[:comp_codes]    = compname
   isstatus               = false; 
   allpackno             = get_all_packlist_against_epsno()
    respond_to do |format|
      format.json { render :json => { 'data'=>allpackno,"message"=>'',:status=>isstatus } }
    end

end



private
def get_proforma_all_bills
  comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
  customers   = params[:iscustomerId]!=nil && params[:iscustomerId]!='' ? params[:iscustomerId] : 0
  if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
     if comp_codes == nil ||  comp_codes == ''
       comp_codes = @compcodes
     end
  end
 objitem =  TrnProformaHdr.select("hd_billnumber").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_loc = ? AND hd_type=? AND hd_customer_id=?", comp_codes,params[:hd_sale_type].to_s,@isLoc.to_s,params[:hd_type],customers]).order('hd_billnumber desc')
 return objitem
end

def get_packlist_all_bills
  comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
  if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
     if comp_codes == nil ||  comp_codes == ''
       comp_codes = @compcodes
     end
  end
 objitem =  TrnPackingInvoice.select("pli_number,id,pli_compcode,pli_local_type").where(["pli_compcode = ? AND pli_sale_type=? AND pli_local_type=?", comp_codes,params[:hd_sale_type],params[:hd_type]]).order('pli_number desc')
 return objitem
end

private
def get_all_packlist_against_epsno
 comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes].to_s.strip : ''
 oa_nos      = params[:oa_nos]!=nil && params[:oa_nos]!='' ? params[:oa_nos].to_s.strip : ''
 hdtype      =  params[:hd_type]!=nil && params[:hd_type]!= '' ? params[:hd_type].to_s.strip : ''
  if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
       if comp_codes == nil ||  comp_codes == ''
         comp_codes = @compcodes
       end
  end
  arr    =  []
  objitem = TrnPackingList.select("pl_number,id,pl_compcode,pl_local_type,'' as newplnumbers").where(["pl_compcode = ? AND pl_sale_type=? AND pl_local_type=? AND pl_oa_number=?", comp_codes,params[:hd_sale_type],params[:hd_type],oa_nos]).order('pl_number desc')
  if objitem.length >0
      objitem.each do |pls|
       pls.newplnumbers  = Base64.encode64(pls.pl_number.to_s+"_"+pls.pl_compcode.to_s+"_"+oa_nos.to_s+"_"+hdtype.to_s).to_s+"_PCK"
       arr.push pls
      end
  end
 
end



private
def get_packlist_all_number
   comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
   if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
       if comp_codes == nil ||  comp_codes == ''
         comp_codes = @compcodes
       end
   end
   arr     = []
   objitem =  TrnPackingInvoice.select("pli_number,'' as newpl_number,pli_local_type,id").where(["pli_compcode = ? AND pli_sale_type= ? AND pli_local_type=?", comp_codes,params[:hd_sale_type],params[:hd_type]]).order('pli_number DESC')
  if objitem.length >0
      objitem.each do |plsd|
        plsd.newpl_number = Base64.encode64(plsd.pli_number+"_"+comp_codes.to_s+"_"+ plsd.pli_local_type.to_s)
        arr.push plsd
      end

  end

  return arr
end

private
def get_customer_details()
   compname    = params[:compname]!='' && params[:compname]!=nil ? params[:compname] : ''
   xtype       = params[:xtype]!='' && params[:xtype]!=nil ? params[:xtype] : ''
   oanumber    = params[:oanumber]!='' && params[:oanumber]!=nil ? params[:oanumber] : ''
  #jons          = " JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  obj    = TrnProformaHdr.select("hd_invoiceto,hd_dispmode,hd_billnumber").where("hd_compcode=? and hd_billnumber=? and hd_type=?",compname,oanumber,xtype).first
  respond_to do |format|
    format.json { render :json => { 'data'=>obj,"message"=>'',:status=>true } }
  end

end ## END IF

private
def get_search_prdname_by_oano
    compname    = params[:compname]!='' && params[:compname]!=nil ? params[:compname] : @compcodes
    xtype       = params[:xtype]!='' && params[:xtype]!=nil ? params[:xtype] : 'Local'
    oanumber    = params[:oanumber]!='' && params[:oanumber]!=nil ? params[:oanumber] : ''
    iswhere     = "hd_compcode = '#{compname}'"
    if xtype!=nil && xtype!=''
       iswhere  += " AND hd_type ='#{xtype}'"
    end
     if oanumber!=nil && oanumber!=''
       iswhere  += " AND hd_billnumber='#{oanumber}'"
     end
     if params[:productname]!='' && params[:productname]!=nil
        productname = params[:productname]+"%"
        iswhere     += " AND dt_itemname LIKE '#{productname}'"
     end
     isselect     = " tds.*,hd_type,hd_billnumber,hd_invoiceto,hd_dispmode,'' as dtweight"
     jons         = " JOIN trn_proforma_details tds ON(dt_compcode=hd_compcode AND hd_billnumber=dt_billnumber AND dt_sale_type=hd_sale_type)"
     isprodname   = TrnProformaHdr.select(isselect).joins(jons).where(iswhere).group('TRIM(dt_itemname)').order('TRIM(dt_itemname) ASC')
     arrp         = []
    if isprodname.length >0
          isprodname.each do |arp|
            compcode = arp.dt_compcode
            pdcode   = arp.dt_itemcode
            prdobj   = get_name_of_product(compcode,pdcode)
             if prdobj
                arp.dtweight  = prdobj.pd_weight
             end
            arrp.push arp
          end
           msg = "success"
           respond_to do |format|
            format.json { render :json => { 'data'=>arrp, "message"=>msg,:status=>true } }
           end
    end
end

private
def save_pack_listing
   comp_codes  =  params[:hd_company]!=nil && params[:hd_company]!='' ? params[:hd_company] : @compcodes
   comp_type   =  params[:hd_type]!=nil && params[:hd_type]!='' ? params[:hd_type] : 'Local'
   @isCode     = 0
   @Startx     = '0000'
  if comp_codes!=nil || comp_codes!= ''
      @recCodes  = TrnPackingInvoice.select("pli_number").where(["pli_compcode = ? AND  pli_sale_type=? AND pli_number >0 AND pli_local_type=?", comp_codes,params[:hd_sale_type],comp_type]).order('pli_number DESC').first
      if @recCodes
       @isCode    = @recCodes.pli_number.to_i
      end
   end
    @sumOfCode    = @isCode.to_i + 1
    if @sumOfCode.to_i < 10
      @sumOfCode = p @Startx.to_s + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 3
      @sumOfCode = p "000" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 4
      @sumOfCode = p "00" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 5
      @sumOfCode = p "0" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length >5
      @sumOfCode =  @sumOfCode.to_i
    end
    if params[:isprocessedupdated]!=nil && params[:isprocessedupdated]!='' && params[:isprocessedupdated]=='Y' && params[:pli_number].to_i >0
		     params[:pli_number] = params[:pli_number]
	   else
		     params[:pli_number] = @sumOfCode
	  end
   params[:pli_sale_type]        =  params[:hd_sale_type]!=nil && params[:hd_sale_type]!='' ? params[:hd_sale_type] : 'S'
   params[:pli_oa_number]        =  params[:pli_oa_number]!=nil && params[:pli_oa_number]!='' ? params[:pli_oa_number] : ''
   params[:pli_cust_locality]    =  params[:custLocality]!=nil && params[:custLocality]!=''  ? params[:custLocality] : ''
   params[:pli_shipto]           =  params[:hd_shipto]!=nil && params[:hd_shipto]!=''  ? params[:hd_shipto] : ''
   params[:pli_shipto_id]        =  params[:hd_shipto_id]!=nil && params[:hd_shipto_id]!=''  ? params[:hd_shipto_id] : 0
   params[:pli_invoices_to]      =  params[:hd_invoiceto]!=nil && params[:hd_invoiceto]!=''  ? params[:hd_invoiceto] : ''
   params[:pli_invoice_to_id]    =  params[:hd_customer_id]!=nil && params[:hd_customer_id]!=''  ? params[:hd_customer_id] : 0
   params[:pli_currency]         =  params[:pli_currency]!=nil && params[:pli_currency]!=''  ? params[:pli_currency] : ''
   params[:pli_ref_no]           =  params[:pli_ref_no]!=nil && params[:pli_ref_no]!=''  ? params[:pli_ref_no] : ''
   ndts = 0
   if  params[:pli_ref_date]!=nil &&  params[:pli_ref_date]!=''
      mdt  = Date.parse(params[:pli_ref_date].to_s)
      ndts  = mdt.strftime("%Y-%m-%d")
   end

   if params[:pli_packlist_no]!=nil && params[:pli_packlist_no]!=''
     splst = params[:pli_packlist_no].to_s.split("_")
     newpackno  = Base64.decode64(splst[0])
     gnpackno   = newpackno.to_s.split("_")
     params[:pli_packlist_no] = gnpackno[0]
   else
     params[:pli_packlist_no] = ''
   end
  dt = 0
  if  params[:pli_date]!=nil  && params[:pli_date]!=''
      ndt = Date.parse(params[:pli_date].to_s)
      dt  = ndt.strftime("%Y-%m-%d")
  end
   params[:pli_compcode]   = comp_codes
   params[:pli_local_type] = comp_type
   params[:pli_date]       = dt
   params[:pli_ref_date]   = ndts
   params.permit(:pli_compcode,:pli_ref_date,:pli_currency,:pli_ref_no,:pli_cust_locality,:pli_number,:pli_date,:pli_sale_type,:pli_local_type,:pli_oa_number,:pli_invoices_to,:pli_invoice_to_id,:pli_shipto,:pli_shipto_id,:pli_packlist_no,:pli_shiping_terms,:pli_payment_terms,:pli_transport,:pli_place_receipt,:pli_port_discharge,:pli_final_destination,:pli_flight_no,:pli_port_loading,:pli_country_origin,:pli_total_qty,:pli_total_dscount,:pli_total_amount,:pli_igst_amount,:pli_cgst_amount,:pli_sgst_amount,:pli_net_amount,:pli_total_pcs,:pli_total_boxno,:pli_total_weight,:pli_total_grosswt)
end

private
def process_grid_data(pldi_number)
   comp_codes         =  params[:hd_company]!=nil && params[:hd_company]!='' ? params[:hd_company] : @compcodes
   comp_type          =  params[:hd_type]!=nil && params[:hd_type]!='' ? params[:hd_type] : 'Local'
   pldi_sale_type     =  params[:hd_sale_type]!=nil && params[:hd_sale_type]!='' ? params[:hd_sale_type] : 'S'
   pldi_oa_number     =  params[:pli_oa_number]!=nil && params[:pli_oa_number]!='' ? params[:pli_oa_number] : ''
   pldi_packing_no    =  ''
   if params[:pli_packlist_no]!=nil && params[:pli_packlist_no]!=''     
     pldi_packing_no =params[:pli_packlist_no]
   end
   pldi_locality_type = comp_type
   
  if params[:dt_itemcode]!='' && params[:dt_itemcode]!=nil
      i = 0
      params[:dt_itemcode].each do |tnd|
            if params[:dt_itemcode][i]!=nil && params[:dt_itemcode][i]!=''
               pldi_itemcode = params[:dt_itemcode][i]
            else
               pldi_itemcode = ''
            end
            if params[:dt_itemname][i]!=nil && params[:dt_itemname][i]!=''
               pldi_itemname = params[:dt_itemname][i]
            else
               pldi_itemname = ''
            end
            if params[:dt_hsncode][i]!=nil && params[:dt_hsncode][i]!=''
               pldi_hsncode = params[:dt_hsncode][i]
            else
               pldi_hsncode = ''
            end
            if params[:dt_quantity][i]!=nil && params[:dt_quantity][i]!=''
               pldi_qty = params[:dt_quantity][i]
            else
               pldi_qty = 0
            end
            if params[:bill_id][i]!=nil && params[:bill_id][i]!=''
               bill_id = params[:bill_id][i]
            else
               bill_id = 0
            end
            if params[:dt_material][i]!=nil && params[:dt_material][i]!=''
               pldi_material = params[:dt_material][i]
            else
               pldi_material = ''
            end
            if params[:dt_color][i]!=nil && params[:dt_color][i]!=''
               pldi_color = params[:dt_color][i]
            else
               pldi_color = ''
            end
            if params[:dt_boxno][i]!=nil && params[:dt_boxno][i]!=''
               pldi_box_no = params[:dt_boxno][i]
            else
               pldi_box_no = 0
            end
           
            if params[:dt_weight][i]!=nil && params[:dt_weight][i]!=''
               pldi_weight = params[:dt_weight][i]
            else
               pldi_weight = 0
            end
            
            if params[:dt_cgstamount][i]!=nil && params[:dt_cgstamount][i]!=''
               pldi_cgst_amt = params[:dt_cgstamount][i]
            else
               pldi_cgst_amt = 0
            end
            if params[:dt_sgstamount][i]!=nil && params[:dt_sgstamount][i]!=''
               pldi_sgst_amt = params[:dt_sgstamount][i]
            else
               pldi_sgst_amt = 0
            end
            if params[:dt_discountamount][i]!=nil && params[:dt_discountamount][i]!=''
               pldi_discount_amt = params[:dt_discountamount][i]
            else
               pldi_discount_amt = 0
            end
            if params[:dt_ref_code][i]!=nil && params[:dt_ref_code][i]!=''
               pldi_cust_prod = params[:dt_ref_code][i]
            else
               pldi_cust_prod = ''
            end
            if params[:dt_rate][i]!=nil && params[:dt_rate][i]!=''
               pldi_rate = params[:dt_rate][i]
            else
               pldi_rate = ''
            end
            if params[:dt_uom][i]!=nil && params[:dt_uom][i]!=''
               pldi_unit = params[:dt_uom][i]
            else
               pldi_unit = ''
            end
            if params[:dt_discount][i]!=nil && params[:dt_discount][i]!=''
               pldi_discount = params[:dt_discount][i]
            else
               pldi_discount = 0
            end
            if params[:dt_amounts][i]!=nil && params[:dt_amounts][i]!=''
               pldi_net_price = params[:dt_amounts][i]
            else
               pldi_net_price = 0
            end
            if params[:gst][i]!=nil && params[:gst][i]!=''
               pldi_gst = params[:gst][i]
            else
               pldi_gst = 0
            end
            if params[:gstamount][i]!=nil && params[:gstamount][i]!=''
               pldi_gst_amt = params[:gstamount][i]
            else
               pldi_gst_amt = 0
            end
            if params[:dt_netamount][i]!=nil && params[:dt_netamount][i]!=''
               pldi_net_amt = params[:dt_netamount][i]
            else
               pldi_net_amt = 0
            end
            if params[:custLocality]!=nil && params[:custLocality]!='' && params[:custLocality]=='out'
              pldi_cgst_amt = 0
              pldi_sgst_amt = 0
            end
             if pldi_qty.to_i >0
                 create_packlist_linking(comp_codes,comp_type,pldi_itemcode,pldi_itemname,pldi_number,pldi_sale_type,pldi_material,pldi_color,pldi_qty,pldi_box_no,pldi_cust_prod,pldi_unit,pldi_rate,pldi_discount,pldi_discount_amt,pldi_net_price,pldi_gst,pldi_gst_amt,pldi_net_amt,pldi_locality_type,pldi_weight,pldi_cgst_amt,pldi_sgst_amt,pldi_oa_number,pldi_hsncode,pldi_packing_no,bill_id)
              end
          i += 1
      end
   end
end

private
def create_packlist_linking(comp_codes,comp_type,pldi_itemcode,pldi_itemname,pldi_number,pldi_sale_type,pldi_material,pldi_color,pldi_qty,pldi_box_no,pldi_cust_prod,pldi_unit,pldi_rate,pldi_discount,pldi_discount_amt,pldi_net_price,pldi_gst,pldi_gst_amt,pldi_net_amt,pldi_locality_type,pldi_weight,pldi_cgst_amt,pldi_sgst_amt,pldi_oa_number,pldi_hsncode,pldi_packing_no,bill_id)
    isobjupdate = TrnPackingInvoiceDetail.where("pldi_compcode=? AND id= ? ",comp_codes,bill_id).first
    @comp_type = comp_type
    if isobjupdate
         isobjupdate.update(:pldi_compcode=>comp_codes,:pldi_oa_number=>pldi_oa_number,:pldi_hsncode=>pldi_hsncode,:pldi_packing_no=>pldi_packing_no,:pldi_itemcode=>pldi_itemcode,:pldi_itemname=>pldi_itemname,:pldi_number=>pldi_number,:pldi_sale_type=>pldi_sale_type,:pldi_material=>pldi_material,:pldi_color=>pldi_color,:pldi_qty=>pldi_qty,:pldi_box_no=>pldi_box_no,:pldi_cust_prod=>pldi_cust_prod,:pldi_unit=>pldi_unit,:pldi_rate=>pldi_rate,:pldi_discount=>pldi_discount,:pldi_discount_amt=>pldi_discount_amt,:pldi_net_price=>pldi_net_price,:pldi_gst=>pldi_gst,:pldi_gst_amt=>pldi_gst_amt,:pldi_net_amt=>pldi_net_amt,:pldi_locality_type=>pldi_locality_type,:pldi_weight=>pldi_weight,:pldi_cgst_amt=>pldi_cgst_amt,:pldi_sgst_amt=>pldi_sgst_amt)
         ## execute message if required
    else
          nobsave =   TrnPackingInvoiceDetail.new(:pldi_compcode=>comp_codes,:pldi_oa_number=>pldi_oa_number,:pldi_hsncode=>pldi_hsncode,:pldi_packing_no=>pldi_packing_no,:pldi_itemcode=>pldi_itemcode,:pldi_itemname=>pldi_itemname,:pldi_number=>pldi_number,:pldi_sale_type=>pldi_sale_type,:pldi_material=>pldi_material,:pldi_color=>pldi_color,:pldi_qty=>pldi_qty,:pldi_box_no=>pldi_box_no,:pldi_cust_prod=>pldi_cust_prod,:pldi_unit=>pldi_unit,:pldi_rate=>pldi_rate,:pldi_discount=>pldi_discount,:pldi_discount_amt=>pldi_discount_amt,:pldi_net_price=>pldi_net_price,:pldi_gst=>pldi_gst,:pldi_gst_amt=>pldi_gst_amt,:pldi_net_amt=>pldi_net_amt,:pldi_locality_type=>pldi_locality_type,:pldi_weight=>pldi_weight,:pldi_cgst_amt=>pldi_cgst_amt,:pldi_sgst_amt=>pldi_sgst_amt)
          if nobsave.save
            ## execute message if required
          end
    end
end

private
def rollback_billing_if_not_acl(billnumber)
      compcodes    =  params[:hd_company]!=nil && params[:hd_company]!='' ? params[:hd_company] : @compcodes
      hdtype      =  params[:hd_type]!=nil && params[:hd_type]!='' ? params[:hd_type] : ''
      @chkObj     =  TrnPackingInvoice.joins('INNER JOIN trn_packing_invoice_details trn ON(pldi_compcode=pli_compcode AND pldi_sale_type=pli_sale_type AND pldi_number=pli_number AND pldi_locality_type=pli_local_type)').where("pli_compcode = ? AND pli_number=? AND pli_sale_type= ? AND pli_local_type=?",ompcodes,billnumber,params[:hd_sale_type],hdtype)
      if @chkObj.length <= 0
          @delObj =  TrnPackingInvoice.where("pli_compcode = ? AND pli_number=? AND pli_sale_type= ? AND pli_local_type=?",compcodes,billnumber,params[:hd_sale_type],hdtype).first
          if @delObj
            @delObj.destroy
          end
      end

end

private
def common_action_rules_sets()   
      @grpName        = MstGroup.where(["gp_compcode = ?", @compcodes])
      @salesName      = MstSale.where(["sl_compcode = ?", @compcodes]).order('TRIM(sl_name) ASC')
      @customerState  = MstCompany.where("cmp_companycode=?",@compcodes).first
      @Location       = MstLocation.where("lc_compcode=?",@compcodes)
      @Countries      = MstInqCountry.all.order("TRIM(country_name) ASC")
      @iModSerial     = true
      cid             = '99'
      @isFlags        = false
      @companyState   = MstInqState.where(["cid = ?", cid])
      
end

private
def get_packing_number_details(xcomp,plnum,oanums,xtyp)
    @compcodes  =  session[:loggedUserCompCode]
     saletype  = 'S'
     arrs      = []
     isselect = "pld_material,pld_color,SUM(pld_qty) as qty,GROUP_CONCAT(pld_box_no) as grpboxno,pld_itemcode,pld_itemname"
     isselect += ",pl_totno_pices,pl_totno_boxno,pl_tot_netweight,pl_tot_grossweight,pl_apprx_value,pl_tot_perkg,'' as netamt"
     isselect += ",'' as igst,'' as igstamt,'' as cgst,'' as sgst,'' as cstamt,'' as sgstamt,'' as discount,'' as discountamt"
     isselect += ",'' as refcode,'' as taxyesno,'' as uom,'' as rates,pld_gross_weight,'' as hsncode"
     jons     = " JOIN trn_packing_list_details pld ON(pl_compcode=pld_compcode AND pl_oa_number=pld_oa_number AND pl_local_type=pld_locality_type)"
     iswhere  = "pl_compcode='#{xcomp}' AND pl_sale_type='#{saletype}' AND pl_local_type='#{xtyp}' AND pl_oa_number='#{oanums}' AND pl_number='#{plnum}'"
     objitem  =  TrnPackingList.select(isselect).joins(jons).where(iswhere).group("pld_itemcode").order('pld_box_no ASC')
     if objitem.length >0
         objitem.each do |mts|
           pdcode = mts.pld_itemcode           
           prd    =  get_name_of_product('all',pdcode)
           cid    = 0
           uid    = 0
           if prd
             mts.taxyesno = prd.pd_taxtincyesno
             mts.refcode  = prd.pd_refer_no
             mts.rates    = currency_formatted(prd.pd_mrps.to_f)
             cid          = prd.pd_category
             uid          = prd.pd_uom
           end           
           cats = get_sel_category(@compcodes,cid)
           if cats
              mts.igst     = cats.pc_igstcode
              mts.cgst     = cats.pc_cgstcode
              mts.sgst     = cats.pc_sgstcode
              mts.hsncode  = cats.pc_hsncode
           end
           uoms = get_sel_units(@compcodes,uid)
           if uoms
              mts.uom  = uoms.pu_shortname
           end
           arrs.push mts
         end
     end  ## end if
end ## end method


end### END CLASS
