class InvoiceSaleController < ApplicationController
   before_action :require_login
   before_action :allowed_pages
   before_action :is_allowed_location
   skip_before_action :verify_authenticity_token,:only=>[:index,:ajax_process]
   include ErpModule::Common
   helper_method :currency_formatted,:get_customer_child_detail,:year_month_days_formatted,:formatted_date,:set_ent,:set_dct
   helper_method :get_sel_category,:get_name_of_product
 def index
     @compcodes  = session[:loggedUserCompCode]
     @cdates     = formatted_date(Time.now.to_date)
     @lastadNo   = get_last_receipt_no
     @bilnos     = nil
     @allAdjust  = TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno >0", @compcodes,@isLoc]).order('ish_billno ASC')
     @empObj     = MstEmployee.where("emp_compcode=? AND emp_designation IN('2')",@compcodes).order("emp_name ASC")
     @stkHead    = nil
     @footerItem = nil
     if params[:id]!=nil && params[:id]!=''
       bilno       = set_dct(params[:id])
       @bilnos     = bilno
       @stkHead    = TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno=?", @compcodes,@isLoc,bilno]).first
       @footerItem = TrnInvoiceSaleDetail.where("ishd_compcode=? AND ishd_storeid=? AND ishd_billno=?",@compcodes,@isLoc,bilno).order("ishd_billno ASC")
     end
end
def create
  @compcodes   = session[:loggedUserCompCode]
  isFlags      = true
  billnumber   = params[:ish_billno]!=nil && params[:ish_billno]!='' ? params[:ish_billno] : ''
  begin
  if params[:ish_billno]=='' || params[:ish_billno]==nil
       flash[:error] =  "Please enter bill no"
       isFlags       = false
  elsif params[:ish_billdate]=='' || params[:ish_billdate]==nil
       flash[:error] =  "Please enter bill date"
       isFlags       = false
 elsif params[:ish_salesman]=='' || params[:ish_salesman]==nil
       flash[:error]  =  "Please select salesman"
       isFlags        = false
   elsif @compcodes ==''  || @compcodes == nil
       flash[:error] =  "Invalid company."
       isFlags       = false
   else

      if isFlags
            @Customersid = process_customer()
            istockobj    = TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno=?", @compcodes,@isLoc,billnumber])
            if  istockobj.length >0
                  istockipd   = TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno=?", @compcodes,@isLoc,billnumber]).first
                  if istockipd
                      istockipd.update(sale_invoice_params)                       
                      set_sale_invoice_footer(billnumber)                  
                      flash[:error] =  "Data updated successfully."
                      isFlags       =  true
                  end
                  
            else
                  istocksave   = TrnInvoiceSaleHead.new(sale_invoice_params)
                  if istocksave.save
                     billnumber = @sumXOfCode
                     set_sale_invoice_footer(billnumber)                     
                     flash[:error] =  "Data saved successfully."
                     isFlags       =  true
                  end
            end
      end

   end
   
   rescue Exception => exc
      flash[:error]            = "#{exc.message}"
      session[:isErrorhandled] = 1
      isFlags = false
      if params[:mid].to_i <=0        
        rollback_billing_if_not_acl(billnumber)
      end

   end

   if !isFlags
     session[:request_params] = params
     session[:isErrorhandled] = 1
     isFlags = false
   else
     session[:request_params] = nil
     session[:isErrorhandled] = nil
     session.delete(:request_params)
   end
    redirect_to "#{root_url}"+"invoice_sale"
end

def invoice_sale_refresh
 session[:request_params] = nil
 session.delete(:request_params)
 redirect_to "#{root_url}"+"invoice_sale"
end

def ajax_process
    @compcodes  = session[:loggedUserCompCode]
    if params[:identity]!=nil && params[:identity]!='' && params[:identity] == 'SCANPD'
         get_new_products()
         return
    elsif params[:identity]!=nil && params[:identity]!='' && params[:identity] == 'CNNO'
         generate_credit_note_no()
         return
    elsif params[:identity]!=nil && params[:identity]!='' && params[:identity] == 'HST'
         get_transaction_history()
         return
    elsif params[:identity]!=nil && params[:identity]!='' && params[:identity] == 'REDIM'
         save_redim_points()
         return
    end
end


def show
   @compcodes  = session[:loggedUserCompCode]

end


 def destroy
 customerid     =  params[:id].to_i
 @compcodes     =  session[:loggedUserCompCode]
 @customerId    =  customerid     
  redirect_to "#{root_url}"+"invoice_sale"
end

def cancel
     @compcodes =  session[:loggedUserCompCode]
     billno     =  params[:id]
     hdobj      =  TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno=?", @compcodes,@isLoc,billno]).first
     if hdobj
          cstatus = hdobj.ish_status
           if cstatus!='C'
                allobj =  TrnInvoiceSaleDetail.where("ishd_compcode=? AND ishd_storeid=? AND ishd_billno=?",@compcodes,@isLoc,billno)
                if allobj.length >0
                      allobj.each do |sld|
                          prdcompcode  = sld.ishd_compcode
                          prdpdcode    = sld.ishd_productcode
                          storeid      = sld.ishd_storeid
                          pdclosingbal = sld.ishd_qty
                          reverse_stock_added(prdcompcode,prdpdcode,storeid,pdclosingbal)
                     end
                end
                if hdobj.update(:ish_status=>'C')                 
                  flash[:error] =  "Data cancelled successfully."
                  isFlags       =  true
                end
           end
     end
    redirect_to "#{root_url}"+"invoice_sale"
end


private
def sale_invoice_params
    @compcodes  = session[:loggedUserCompCode]
    @isCode     = 0
    @Startx     = '0000'
    @recCodes   = TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno >0", @compcodes,@isLoc]).order('ish_billno DESC').first
    if @recCodes
       @isCode    = @recCodes.ish_billno.to_i
    end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_i < 10
      @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
      @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
      @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
      @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >5
      @sumXOfCode =  @sumXOfCode.to_i
    end
    if params[:mid].to_i <=0
      params[:ish_billno] = @sumXOfCode
    else
      params[:ish_billno] = params[:ish_billno]
    end  
  dates = 0
  if params[:ish_billdate]!=nil && params[:ish_billdate]!=''
    dates = year_month_days_formatted(params[:ish_billdate])
  end
  params[:ish_compcode]      = @compcodes
  params[:ish_billdate]      = dates
  params[:ish_storeid]       = @isLoc
  params[:ish_salesman]      = params[:ish_salesman]!=nil && params[:ish_salesman]!='' ? params[:ish_salesman] : 0
  params[:ish_permcode]      = params[:ish_permcode]!=nil && params[:ish_permcode]!='' ? params[:ish_permcode] : ''
  params[:ish_remarks]       = params[:ish_remarks]!=nil && params[:ish_remarks]!='' ? params[:ish_remarks] : ''
  params[:ish_card]          = params[:ish_card]!=nil && params[:ish_card]!='' ? params[:ish_card] : ''
  params[:ish_valuecard]     = params[:ish_valuecard]!=nil && params[:ish_valuecard]!='' ? params[:ish_valuecard] : ''
  params[:ish_cardamnt]      = params[:ish_cardamnt]!=nil && params[:ish_cardamnt]!='' ? params[:ish_cardamnt] : 0
  params[:ish_promo_coupon]  = params[:ish_promo_coupon]!=nil && params[:ish_promo_coupon]!='' ? params[:ish_promo_coupon] : ''
  params[:ish_totalvalue]    = params[:ish_totalvalue]!=nil && params[:ish_totalvalue]!='' ? params[:ish_totalvalue] : 0
  params[:ish_totaltaxable]  = params[:ish_totaltaxable]!=nil && params[:ish_totaltaxable]!='' ? params[:ish_totaltaxable] : 0
  params[:ish_total_netamt]  = params[:ish_total_netamt]!=nil && params[:ish_total_netamt]!='' ? params[:ish_total_netamt] : 0
  params[:ish_total_qty]     = params[:ish_total_qty]!=nil && params[:ish_total_qty]!='' ? params[:ish_total_qty] : 0
  params[:ish_totaligstamt]  = params[:ish_totaligstamt]!=nil && params[:ish_totaligstamt]!='' ? params[:ish_totaligstamt] : 0
  params[:ish_totalcgstamt]  = params[:ish_totalcgstamt]!=nil && params[:ish_totalcgstamt]!='' ? params[:ish_totalcgstamt] : 0
  params[:ish_totalsgstamt]  = params[:ish_totalsgstamt]!=nil && params[:ish_totalsgstamt]!='' ? params[:ish_totalsgstamt] : 0
  params[:ish_totaldiscamt]  = params[:ish_totaldiscamt]!=nil && params[:ish_totaldiscamt]!='' ? params[:ish_totaldiscamt] : 0
  params[:ish_totaltaxamt]   = params[:ish_totaltaxamt]!=nil && params[:ish_totaltaxamt]!='' ? params[:ish_totaltaxamt] : 0
  params[:ish_totalbalamt]   = params[:ish_total_netamt]
  params[:ish_creditnotno]   = params[:ish_creditnotno]!=nil && params[:ish_creditnotno]!='' ? params[:ish_creditnotno] : ''
  params[:ish_paycashamt]    = params[:ish_paycashamt]!=nil && params[:ish_paycashamt]!='' ? params[:ish_paycashamt] : 0
  params[:ish_paycardamt]    = params[:ish_paycardamt]!=nil && params[:ish_paycardamt]!='' ? params[:ish_paycardamt] : 0
  params[:ish_customerid]    = @Customersid
  params[:ish_paytype]       = params[:ish_paytype]!=nil && params[:ish_paytype]!='' ? params[:ish_paytype] : ''
  params[:ish_paycustomer]   = params[:customername]!=nil && params[:customername]!='' ? params[:customername].to_s.strip : 0
  params[:ish_paycustmobile] = params[:customermob]!=nil && params[:customermob]!='' ? params[:customermob].to_s.strip : 0
  params[:ish_ccinvoice]     = params[:ish_ccinvoice]!=nil && params[:ish_ccinvoice]!='' ? params[:ish_ccinvoice] : ''
  params[:ish_ccno]          = params[:ish_ccno]!=nil && params[:ish_ccno]!='' ? params[:ish_ccno] : ''
  params.permit(:ish_compcode,:ish_customerid,:ish_storeid,:ish_billno,:ish_billdate,:ish_salesman,:ish_permcode,:ish_remarks,:ish_card,:ish_valuecard,:ish_cardamnt,:ish_promo_coupon,:ish_totalvalue,:ish_totaltaxable,:ish_total_netamt,:ish_total_qty,:ish_totaligstamt,:ish_totalcgstamt,:ish_totalsgstamt,:ish_totaldiscamt,:ish_totaltaxamt,:ish_totalbalamt,:ish_creditnotno,:ish_paycashamt,:ish_paycardamt,:ish_paytype,:ish_paycustomer,:ish_paycustmobile,:ish_ccinvoice,:ish_ccno)

end

private
def check_customer_group_exist
    @isDelFlags = false
    @isItems  = MstCustomer.select('id').where("(cs_compcode = ? AND cs_groupname = ? )",@compcodes,@customerId)
   if @isItems.count >0
      @isDelFlags = true
   end
end

private
def get_last_receipt_no
  @xLoc       = (session[:autherizedLoc].to_i >0) ? session[:autherizedLoc] : 0
  @isCode     = 0
  @Startx     = '0000'
  @recCodes   = TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno >0", @compcodes,@isLoc]).order('ish_billno DESC').first
   if @recCodes
      @isCode    = @recCodes.ish_billno.to_i
   end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_i < 10
      @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
      @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
      @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
      @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >5
      @sumXOfCode =  @sumXOfCode.to_i
    end
    return @sumXOfCode
end


def rollback_billing_if_not_acl(billnumber)
      @chkObj =  TrnInvoiceSaleHead.joins('INNER JOIN trn_invoice_sale_details trn ON(ishd_compcode=ish_compcode AND ishd_storeid=ish_storeid AND ishd_billno=ish_billno)').where("ish_compcode = ? AND ish_storeid=? AND ish_billno=?",@compcodes,@isLoc,billnumber)
      if @chkObj.length <= 0
         @delObj =  TrnInvoiceSaleHead.where("ish_compcode = ? AND ish_storeid=? AND ish_billno=?",@compcodes,@isLoc,billnumber)
         @delObj.delete_all
      end
end

private
def set_sale_invoice_footer(ishd_billno)
   ishd_compcode =  @compcodes
   ishd_storeid  =  @isLoc
   
  if params[:prodcode]!='' && params[:prodcode]!=nil
      i = 0
      params[:prodcode].each do |tnd|

            if params[:prodcode][i]!=nil && params[:prodcode][i]!=''
               ishd_productcode = params[:prodcode][i]
            else
               ishd_productcode = ''
            end
            if params[:oldstocks][i]!=nil && params[:oldstocks][i]!=''
               oldstocks = params[:oldstocks][i]
            else
               oldstocks = 0
            end
            if params[:color][i]!=nil && params[:color][i]!=''
               ishd_color = params[:color][i]
            else
               ishd_color = ''
            end

            if params[:size][i]!=nil && params[:size][i]!=''
               ishd_size = params[:size][i]
            else
               ishd_size = ''
            end
            if params[:stocks][i]!=nil && params[:stocks][i]!=''
               ishd_qty = params[:stocks][i]
            else
               ishd_qty = 0
            end
            if params[:nmrp][i]!=nil && params[:nmrp][i]!=''
               ishd_rate = params[:nmrp][i]
            else
               ishd_rate = 0
            end
            if params[:nvalue][i]!=nil && params[:nvalue][i]!=''
               ishd_value = params[:nvalue][i]
            else
               ishd_value = 0
            end

            if params[:mydiscount][i]!=nil && params[:mydiscount][i]!=''
               ishd_discount = params[:mydiscount][i]
            else
               ishd_discount = 0
            end
            if params[:mydiscountamt][i]!=nil && params[:mydiscountamt][i]!=''
               ishd_discamount = params[:mydiscountamt][i]
            else
               ishd_discamount = 0
            end

            if params[:mytaxes][i]!=nil && params[:mytaxes][i]!=''
               ishd_tax = params[:mytaxes][i]
            else
               ishd_tax = 0
            end
            if params[:mytaxamt][i]!=nil && params[:mytaxamt][i]!=''
               ishd_taxamount = params[:mytaxamt][i]
            else
               ishd_taxamount = 0
            end
            if params[:mynetamt][i]!=nil && params[:mynetamt][i]!=''
               ishd_netamount = params[:mynetamt][i]
            else
               ishd_netamount = 0
            end


            if params[:mytaxable][i]!=nil && params[:mytaxable][i]!=''
               ishd_taxablevalue = params[:mytaxable][i]
            else
               ishd_taxablevalue = 0
            end

            if params[:myigst][i]!=nil && params[:myigst][i]!=''
               ishd_igst = params[:myigst][i]
            else
               ishd_igst = 0
            end
             if params[:mycgst][i]!=nil && params[:mycgst][i]!=''
               ishd_cgst = params[:mycgst][i]
            else
               ishd_cgst = 0
            end
            if params[:mysgst][i]!=nil && params[:mysgst][i]!=''
               ishd_sgst = params[:mysgst][i]
            else
               ishd_sgst = 0
            end


            if params[:myigstamt][i]!=nil && params[:myigstamt][i]!=''
               ishd_igstamt = params[:myigstamt][i]
            else
               ishd_igstamt = 0
            end
            if params[:mycgstamt][i]!=nil && params[:mycgstamt][i]!=''
               ishd_cgstamt = params[:mycgstamt][i]
            else
               ishd_cgstamt = 0
            end
            if params[:mysgstamt][i]!=nil && params[:mysgstamt][i]!=''
               ishd_sgstamt = params[:mysgstamt][i]
            else
               ishd_sgstamt = 0
            end

            if params[:footerid][i]!=nil && params[:footerid][i]!=''
               footerid = params[:footerid][i]
            else
               footerid = 0
            end

              if ishd_productcode!=nil && ishd_productcode!='' && ishd_qty.to_i >0
                 create_customer_footer(ishd_compcode,ishd_storeid,ishd_billno,ishd_productcode,oldstocks,ishd_size,ishd_color,ishd_qty,ishd_rate,ishd_value,ishd_discount,ishd_discamount,ishd_tax,ishd_taxamount,ishd_netamount,ishd_taxablevalue,ishd_igst,ishd_cgst,ishd_sgst,ishd_igstamt,ishd_cgstamt,ishd_sgstamt,footerid)
              end
          i += 1
      end
   end

end

private
def create_customer_footer(ishd_compcode,ishd_storeid,ishd_billno,ishd_productcode,oldstocks,ishd_size,ishd_color,ishd_qty,ishd_rate,ishd_value,ishd_discount,ishd_discamount,ishd_tax,ishd_taxamount,ishd_netamount,ishd_taxablevalue,ishd_igst,ishd_cgst,ishd_sgst,ishd_igstamt,ishd_cgstamt,ishd_sgstamt,footerid)
    storeid  = @isLoc
    if footerid.to_i >0
            isupdtsobj =  TrnInvoiceSaleDetail.where("stad_compcode=? AND id=?",ishd_compcode,footerid).first
            if isupdtsobj
                isupdtsobj.update(:ishd_compcode=>ishd_compcode,:ishd_storeid=>ishd_storeid,:ishd_billno=>ishd_billno,:ishd_productcode=>ishd_productcode,:ishd_size=>ishd_size,:ishd_color=>ishd_color,:ishd_qty=>ishd_qty,:ishd_rate=>ishd_rate,:ishd_value=>ishd_value,:ishd_discount=>ishd_discount,:ishd_discamount=>ishd_discamount,:ishd_tax=>ishd_tax,:ishd_taxamount=>ishd_taxamount,:ishd_netamount=>ishd_netamount,:ishd_taxablevalue=>ishd_taxablevalue,:ishd_igst=>ishd_igst,:ishd_cgst=>ishd_cgst,:ishd_sgst=>ishd_sgst,:ishd_igstamt=>ishd_igstamt,:ishd_cgstamt=>ishd_cgstamt,:ishd_sgstamt=>ishd_sgstamt)
                ### execute a messages if required
                reverse_stock_added(ishd_compcode,ishd_productcode,storeid,oldstocks)
                stok_added(ishd_compcode,ishd_productcode,storeid,ishd_qty)
             end
     else
           isaveobj =  TrnInvoiceSaleDetail.new(:ishd_compcode=>ishd_compcode,:ishd_storeid=>ishd_storeid,:ishd_billno=>ishd_billno,:ishd_productcode=>ishd_productcode,:ishd_size=>ishd_size,:ishd_color=>ishd_color,:ishd_qty=>ishd_qty,:ishd_rate=>ishd_rate,:ishd_value=>ishd_value,:ishd_discount=>ishd_discount,:ishd_discamount=>ishd_discamount,:ishd_tax=>ishd_tax,:ishd_taxamount=>ishd_taxamount,:ishd_netamount=>ishd_netamount,:ishd_taxablevalue=>ishd_taxablevalue,:ishd_igst=>ishd_igst,:ishd_cgst=>ishd_cgst,:ishd_sgst=>ishd_sgst,:ishd_igstamt=>ishd_igstamt,:ishd_cgstamt=>ishd_cgstamt,:ishd_sgstamt=>ishd_sgstamt)
           if isaveobj.save
              stok_added(ishd_compcode,ishd_productcode,storeid,ishd_qty)
               ### execute a messages if required
           end

     end
end

private
def get_new_products
      retfrom    = @isLoc # params[:retFrom]
      stocks     = params[:stocks]
      iswhere    = "pd_compcode = '#{@compcodes}'"
      if params[:barcode]!='' && params[:barcode]!=nil
           barcodes = params[:barcode]
           iswhere  += " AND pd_barcode ='#{barcodes}'"
      end

      status      = false
      isselect    =  " '' as sid_apply_qty,pd_discount,'' as sid_storeid,pd_productcode as sid_prodcode,pd_productname as pdname,'' as sizes,'' as colors,'' as sid_boxno"
      isselect    += ",pd_compcode as sid_compcode,'' as sid_orderqty,'' as sid_lockstatus,'' as stockinhand,pd_purprice_inr as nmrp,pd_barcode,'' as billno"
      isselect    += ",'' as taxes,'' as discounts"
      prodobjs    =  MstProduct.select(isselect).where(iswhere)
      arrpd       =  []
      isstatus    =  0
      
       if prodobjs
           prodobjs.each do |prodobj|
                 status              = true
                 compcode            = prodobj.sid_compcode
                 pdcode              = prodobj.sid_prodcode
                 prodobj.sid_boxno   = ''
                 prodobj.sid_storeid = retfrom
                 stdobj              =  get_storewise_stock(compcode,pdcode,retfrom)
                 if stdobj
                      if stdobj.tstock.to_f >0 && stdobj.tstock.to_f >=stocks.to_f

                                prodobj.stockinhand  = stdobj.tstock.to_f-stocks.to_f
                                pdobj                = get_all_of_product(compcode,pdcode)
                                if pdobj
                                     prodobj.pdname    = pdobj.pd_productname
                                     prodobj.discounts = prodobj.pd_discount
                                     colobj  = get_pd_color(compcode,pdobj.pd_colors)
                                     if colobj
                                         prodobj.colors = colobj.cls_name
                                     end
                                     szobj   = get_pd_sizes(compcode,pdobj.pd_sizes)
                                     if szobj
                                         prodobj.sizes = szobj.sz_size
                                     end
                                     if pdobj.pd_category.to_i >0
                                        catobj = get_sel_category(compcode,pdobj.pd_category)
                                        if catobj
                                          prodobj.taxes = catobj.pc_igstcode
                                        end
                                     end

                                 end                                 
                              arrpd.push prodobj
                              isstatus = 1
                        end
                        if isstatus.to_i<=0
                          isstatus = 2
                        end

                  end
             end
       end
       respond_to do |format|
         format.json { render :json => { 'data'=>arrpd, "message"=>@msg,:status=>status,'mstatus'=>isstatus } }
       end
end

private
 def generate_credit_note_no   
    @compcodes  = session[:loggedUserCompCode]
    retno       = params[:retno]
    chcnoobj    = TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno=?", @compcodes,@isLoc,retno])
    if chcnoobj.length <=0
          @isCode     = 0
          @Startx     = '0000'
          @recCodes   = TrnInvoiceSaleHead.where(["ish_compcode = ? AND ish_storeid = ? AND ish_billno=?", @compcodes,@isLoc,retno]).order('ish_creditnotno DESC').first
          if @recCodes
            @isCode    = @recCodes.ish_creditnotno.to_i
          end
          crdno    = @isCode.to_i + 1
          if crdno.to_i < 10
            crdno = p @Startx.to_s + crdno.to_s
          elsif crdno.to_s.length < 3
            crdno = p "000" + crdno.to_s
          elsif crdno.to_s.length < 4
            crdno = p "00" + crdno.to_s
          elsif crdno.to_s.length < 5
            crdno = p "0" + crdno.to_s
          elsif crdno.to_s.length >5
            crdno =  crdno.to_i
          end
    else
        crdno = chcnoobj[0].ish_creditnotno
    end

    status  = true
     respond_to do |format|
       format.json { render :json => { 'data'=>'', "message"=>'',:status=>status,'cnno'=>crdno } }
     end
 end

 private
 def process_customer
   mobile                   = params[:customermob]!='' && params[:customermob]!=nil ? params[:customermob].to_s.delete(' ') : ''   
   customerid               = 0
   if mobile!='' && mobile!=nil
        svcustomer = MstStoreCustomer.where("scs_compcode=? AND replace(scs_mobile,' ','')=?",@compcodes,mobile)
         if svcustomer.length >0
           customerid = svcustomer[0].id
            ## Execute if required
         else
             @svsobj = MstStoreCustomer.new(store_cust_params)
             if @svsobj.save
               customerid = p @svsobj.id.to_i
               ## Execute if required
             end
         end
    end
    return customerid
 end


 private
def store_cust_params
  params[:scs_compcode]    = session[:loggedUserCompCode]
  params[:scs_name]        = params[:customername]!=nil && params[:customername]!='' ? params[:customername].to_s.strip : ''
  params[:scs_mobile]      = params[:customermob]!=nil && params[:customermob]!='' ? params[:customermob].to_s.strip : ''
  params[:scs_email]       = ''
  params[:scs_billno]      = ''
  params[:scs_address]     = ''
  params[:scs_member]      = 'N'
  params[:scs_obpoints]    = 0
  params[:scs_pins]        = ''
  params.permit(:scs_compcode,:scs_name,:scs_mobile,:scs_email,:scs_billno,:scs_address,:scs_member,:scs_obpoints,:scs_pins)
end

 
private
def stok_added(prdcompcode,prdpdcode,storeid,pdclosingbal)
    pdclobj =  MstClosingBalance.where("cb_compcode=? AND cb_pdcode=? AND cb_loc=?",prdcompcode,prdpdcode,storeid).first
    if pdclobj
        oldcb  = pdclobj.cb_closing_bal.to_f
        nyob   = pdclosingbal
        ncb    = oldcb.to_f-nyob.to_f
        pdclobj.update(:cb_closing_bal=>ncb)
    end
end

private
def reverse_stock_added(prdcompcode,prdpdcode,storeid,pdclosingbal)
    pdclobj    =  MstClosingBalance.where("cb_compcode=? AND cb_pdcode=? AND cb_loc=?",prdcompcode,prdpdcode,storeid).first
    if pdclobj
        oldcb  = pdclobj.cb_closing_bal.to_f
        nyob   = pdclosingbal
        ncb    = oldcb.to_f+nyob.to_f
        pdclobj.update(:cb_closing_bal=>ncb)
    end
end

private
 def get_transaction_history
    @compcodes  = session[:loggedUserCompCode]
    mobileno    = params[:mobileno]!=nil && params[:mobileno]!='' ? params[:mobileno] : ''
    isselect    = " DATE_FORMAT(ish_billdate,'%d-%b-%Y') as bildate,ish_storeid,ish_billno,ish_totaldiscamt,ish_totalvalue,ish_paycustomer"
    stobj       = TrnInvoiceSaleHead.select(isselect).where(["ish_compcode = ? AND ish_storeid = ? AND ish_paycustmobile=?", @compcodes,@isLoc,mobileno])
    status      = false
    if stobj.length >0
      status = true
    end   
     respond_to do |format|
       format.json { render :json => { 'data'=>stobj, "message"=>'',:status=>status} }
     end
 end
 
 private
 def save_redim_points
     mobileno   = params[:mobileno]!=nil && params[:mobileno]!='' ? params[:mobileno].to_s.strip : ''
     myredim    = params[:myredim]!=nil && params[:myredim]!='' ? params[:myredim] : 0
     status     = false
     message    = ''
     svcstobj   = MstStoreCustomer.where("scs_compcode=? AND replace(scs_mobile,' ','')=?",@compcodes,mobileno)
     if svcstobj.length >0
          custmerid = svcstobj[0].id
          cpoints   = svcstobj[0].scs_obpoints
          npoints   = cpoints.to_i+myredim.to_i
          svupd     = MstStoreCustomer.where("scs_compcode=? AND id=?",@compcodes,custmerid).first
          if svupd
            svupd.update(:scs_obpoints=>npoints)
             status  = true
             message = 'Data saved successfully.'
          end
     end
     respond_to do |format|
       format.json { render :json => { 'data'=>'', "message"=>message,:status=>status} }
     end

 end

end


