class TrnenquiryController < ApplicationController
   before_action :require_login
   before_action :allowed_pages
   before_action :is_allowed_location
   skip_before_action :verify_authenticity_token
  def index
    @compcodes            =  session[:loggedUserCompCode]
    @logedId              =  session[:autherizedUserId]
    @xLoc                 =  session[:autherizedLoc]
    @isFlags              =  false
    @cdate                =  Time.now.strftime('%d-%b-%Y')
    @lastbill             =  get_last_bill_dt
    @Productitem          =  get_product_list
    @companyItems         = MstCompany.select("cmp_companyname,cmp_email,cmp_cell_number,cmp_cont_name").where(["cmp_companycode<>?", @compcodes]).order("TRIM(cmp_companyname) ASC")
  end
  
  def create
    @compcodes     =  session[:loggedUserCompCode]
    @logedId       =  session[:autherizedUserId]
    @xLoc          =  session[:autherizedLoc]
    isFlags        =  true
    begin
        if params[:enq_number]==nil || params[:enq_number]==''
               flash[:error] =  "Please provide enquiry number."
               isFlags       =  false
        elsif params[:enq_date]==nil || params[:enq_date]==''
               flash[:error] =  "Please enter date"
               isFlags       =  false
        
        else
          trnobj  = TrnEnquiry.new(save_enquiry)
          if trnobj.save
               attach_all_files(params[:enq_number])
               flash[:error] =  "Data saved successfully."
               isFlags       =  false
          end

        end
   rescue Exception => exc
     flash[:error] =  "ERROR: #{exc.message}"
     isFlags = false
     session[:isErrorhandled] = 1
   end
   if isFlags
     session[:isErrorhandled] = nil
   else
     session[:isErrorhandled] = 1
   end
    redirect_to "#{root_url}trnenquiry"
  end

  
  def update

  end
  def destroy

  end

 def enquiry_approval
    @compcodes            =  session[:loggedUserCompCode]
    @logedId              =  session[:autherizedUserId]
    @xLoc                 =  session[:autherizedLoc]
    @isFlags              =  false
    @cdate                =  Time.now.strftime('%d-%b-%Y')
    @allEnq               =  TrnEnquiry.select("enq_number").where(["enq_compcode = ?", @compcodes]).order('enq_number ASC')
    @companyItems         =  MstCompany.select("cmp_companyname").where(["cmp_companycode<>?", @compcodes]).order("TRIM(cmp_companyname) ASC")
    @objUser              =  User.select('firstname,username,id').where("usercompcode = ?",@compcodes ).order("TRIM(firstname) ASC")
    if params[:page]!=nil && params[:page].to_i >0
        @pages = params[:page]
     else
        @pages = 1
     end
    @AppList              =  get_approval_list
 end

 private
 def get_approval_list
   
   enq_number   =  params[:enq_number]!=nil && params[:enq_number] ? params[:enq_number] : ''
   enq_date     =  params[:enq_date]!=nil && params[:enq_date] ? params[:enq_date] : nil
   enq_upto     =  params[:enq_upto]!=nil && params[:enq_upto] ? params[:enq_upto] : nil
   enq_srctype  =  params[:enq_source_type]!=nil && params[:enq_source_type] ? params[:enq_source_type] : ''
   enq_agent    =  params[:enq_agent]!=nil && params[:enq_agent] ? params[:enq_agent] : ''
   enq_company  =  params[:enq_company]!=nil && params[:enq_company] ? params[:enq_company] : ''
   enq_mobile   =  params[:enq_mobile]!=nil && params[:enq_mobile] ? params[:enq_mobile] : ''
   @enq_number  = enq_number
   @enq_date    = enq_date
   @enq_upto    = enq_upto
   @enq_srctype = enq_srctype
   @enq_agent   = enq_agent
   @enq_company = enq_company
   @enq_mobile  = enq_mobile
   iswhere      = "enq_compcode='#{@compcodes}'"
   
   if enq_number!=nil && enq_number!=''
     iswhere     += " AND enq_number='#{enq_number}'"
     session[:enq_number] = enq_number
   end
   if enq_date!=nil && enq_date!=''
     dt  = Date.parse(enq_date.to_s)
     ndt = dt.strftime("%Y-%m-%d")
     iswhere     += " AND enq_date >='#{ndt}'"
     session[:enq_date] = enq_date
   end
   if enq_upto!=nil && enq_upto!=''
     udt  = Date.parse(enq_upto.to_s)
     undt = udt.strftime("%Y-%m-%d")
     iswhere     += " AND enq_date <='#{undt}'"
     session[:enq_upto] = enq_upto
   end
   if enq_srctype!=nil && enq_srctype!=''
     iswhere     += " AND enq_source_type='#{enq_srctype}'"
     session[:enq_source_type] = enq_srctype
   end
   if enq_agent!=nil && enq_agent!=''
     iswhere     += " AND enq_agent='#{enq_agent}'"
     session[:enq_agent] = enq_agent
   end
   if enq_company!=nil && enq_company!=''
     iswhere     += " AND enq_company_name LIKE '%#{enq_company}%'"
     session[:enq_company] = enq_company
   end
   if enq_mobile!=nil && enq_mobile!=''
     iswhere     += " AND enq_mobile='#{enq_mobile}'"
     session[:enq_mobile] = enq_mobile
   end
   apprvallist  =  TrnEnquiry.where(iswhere).order('TRIM(enq_number) ASC').paginate(:page =>@pages,:per_page => 10)
   return apprvallist
 end

private
def save_enquiry
   params[:enq_compcode] = @compcodes
   enq_date =  params[:enq_date]!=nil &&  params[:enq_date]!='' ?  params[:enq_date] : ''
   if enq_date!=nil && enq_date!=''
     dt       = Date.parse(enq_date.to_s)
     enq_date = dt.strftime("%Y-%m-%d")
   end
   params[:enq_date]             =  enq_date
   params[:enq_source_type]      =  params[:enq_source_type]!=nil &&  params[:enq_source_type]!='' ?  params[:enq_source_type] : ''
   params[:enq_number]           =  params[:enq_number]!=nil &&  params[:enq_number]!='' ?  params[:enq_number] : ''

   params[:enq_agent]            =  params[:enq_agent]!=nil &&  params[:enq_agent]!='' ?  params[:enq_agent] : 0
   params[:enq_product_id]       =  params[:enq_product_id]!=nil &&  params[:enq_product_id]!='' ?  params[:enq_product_id] : 0
   params[:enq_new_requirement]  =  params[:enq_new_requirement]!=nil &&  params[:enq_new_requirement]!='' ?  params[:enq_new_requirement] : ''
   params[:enq_remarks]          =  params[:enq_remarks]!=nil &&  params[:enq_remarks]!='' ?  params[:enq_remarks] : ''
   params[:enq_company_name]     =  params[:enq_company_name]!=nil &&  params[:enq_company_name]!='' ?  params[:enq_company_name] : ''
   params[:enq_email]            =  params[:enq_email]!=nil &&  params[:enq_email]!='' ?  params[:enq_email] : ''   
   
   params[:enq_attach_file]      =  ''
   if params[:enq_company_name] == nil || params[:enq_company_name] == ''
     params[:enq_company_name]     =  params[:enq_company_name_s]!=nil &&  params[:enq_company_name_s]!='' ?  params[:enq_company_name_s] : ''
     params[:enq_email]            =  params[:enq_email_s]!=nil &&  params[:enq_email_s]!='' ?  params[:enq_email_s] : ''     
     params[:enq_cont_person]      =  params[:enq_cont_person_s]!=nil &&  params[:enq_cont_person_s]!='' ?  params[:enq_cont_person_s] : ''
     params[:enq_mobile]           =  params[:enq_mobile_s]!=nil &&  params[:enq_mobile_s]!='' ?  params[:enq_mobile_s] : ''
     params[:enq_new_company]      =  params[:enq_company_name_s]!=nil &&  params[:enq_company_name_s]!='' ?  params[:enq_company_name_s] : ''
   else
     params[:enq_new_company]      =  ''
   end

  params.permit(:enq_compcode,:enq_number,:enq_new_company,:enq_date,:enq_source_type,:enq_agent,:enq_product_id,:enq_new_requirement,:enq_remarks,:enq_company_name,:enq_email,:enq_cont_person,:enq_mobile)
end

private
def attach_all_files(enqId)
     if params[:ef_enquiry_file]!=nil && params[:ef_enquiry_file]!=''
       i = 0
       k = 1
          params[:ef_enquiry_file].each do |fils|
              if  params[:ef_enquiry_file][i]!=nil &&  params[:ef_enquiry_file][i]!=''
               
                   filename = params[:ef_enquiry_file][i]
                   imgtitle = params[:ef_img_title][i]
                   filex   = attach_files(filename,k)
               else
                   filex  =  ''
               end
               if filex!=nil && filex!=''
               process_enquiry_files(enqId,@compcodes,filex,imgtitle)
               end
               i +=1
               k +=1
         end
     end
end

private
def process_enquiry_files(enqId,compcodes,files,titles)
  if files!=nil && files!='' && enqId!=nil && enqId!=''
    objenq = TrnEnquiryFile.new(:ef_compcode=>compcodes,:ef_enquiry_number=>enqId,:ef_enquiry_file=>files,:ef_img_title=>titles)
    if objenq.save
      ## execute message
    end
  end
end

private
def get_product_list
     isproduct = MstProduct.select("pd_productname,id,pd_productcode").where("pd_compcode=?",@compcodes).order("TRIM(pd_productname) ASC")
     return isproduct
end
private
def get_last_bill_dt
    @xLoc       = (session[:autherizedLoc].to_i >0) ? session[:autherizedLoc] : 0
    @isCode     = 0
    @Startx     = '0000'
     @recCodes  = TrnEnquiry.select("enq_number as hd_billnumber").where(["enq_compcode = ?", @compcodes]).order('enq_number DESC').first
     if @recCodes
       @isCode    = @recCodes.hd_billnumber.to_i
     end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_i < 10
      @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
      @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
      @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
      @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >5
      @sumXOfCode =  @sumXOfCode.to_i
    end
    isnewautonumber = @sumXOfCode
    return isnewautonumber
end
private
  def attach_files(files,cnt)
    file_name     =  files.original_filename  if  ( files !='')
    file          =  files.read
    file_type     =  file_name.split('.').last
    new_name_file = Time.now.to_i+cnt.to_i
    new_file_name = "#{new_name_file}." + file_type
    @Imgs         = new_file_name
    @paths        = Rails.root.join "public", "images", "attachfile"
     
    ######### Upload here ######################
    File.open("#{@paths}/" +new_file_name, "wb")  do |f|
      f.write(file)
    end
    return new_file_name
  end

end
