# To change this template, choose Tools | Templates
# and open the template in the editor.

class IssuereturnPdf < Prawn::Document
  def initialize(invoice,loc,shipto,compDetail,cstype,uRl,isProforma,isTakeTax,gprams,islud,isrndamount)
    super(:margin_top=>20,:page_size => [700, 700],:page_layout => :landscape)
    @invoice    = invoice
    @loc        = loc
    @shipto     = shipto
    @compDetail = compDetail
    @cstype     = cstype
    @uRl2       = uRl
    @uRl        = Rails.root.join "public"
    @logoSize   = 0.5
    @isProforma = isProforma
    @isTakeTax  = isTakeTax
    @isGstNumb  = ""
    @islud      = islud.to_s
    @godaamsx   =  (@compDetail.cmp_godam_allowed=='Y' ) ? true : false
    @isrndamt   = ( isrndamount!='' && isrndamount=='Y' ) ? true : false
    @from_date  = gprams[:from_date].to_s
    @upto_date  = gprams[:upto_date].to_s
    if @islud!='' && @islud!=nil
      @cstype = 'notlocal'
    end
    make_sum_of_all
    issue_line_items
 end
 
  def terms_and_conditions
       "Terms and Conditions"
  end
  def count_mcell
  @count_cell ||= 0
  @count_cell = @count_cell+1
end
  def issue_line_items
          move_down 2
          pad(200) { text "" }
          # header
          bounding_box [bounds.left, bounds.top], :width  => bounds.width do
          font "Helvetica"          
          if @compDetail.cmp_show_logo =='Y'
                if @compDetail.cmp_logos.to_s.length >1
                     @filesExt = Rails.root.join "public", "images", "logo","thumb",@compDetail.cmp_logos.to_s
                     if File.exist?(@filesExt)
                      image open(@uRl+"images/logo/thumb/"+@compDetail.cmp_logos.to_s),:scale => @logoSize,:position => :right,:vposition => :top
                     else
                       pad(10) { text "" }
                     end
                end
          else
                pad(10) { text "" }
          end
        
          move_down 5
          #text @invoice[0].un_name.to_s.upcase, :align => :left, :size => 10
          #text @invoice[0].un_address.to_s, :align => :left, :size => 9
          if @compDetail.cmp_companyname.to_s!=nil && @compDetail.cmp_companyname.to_s!=''
          text @compDetail.cmp_companyname.to_s.upcase, :align => :left, :size => 10,:vposition => :top
          end
          text ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? @compDetail.cmp_addressline1.to_s: '' )+((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? ', ': '' )+@compDetail.cmp_addressline2.to_s : '')+((@compDetail.cmp_addressline3.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ', ': '' )+@compDetail.cmp_addressline3.to_s: ''), :align => :left, :size => 9
          text "Contact Details :"+((@compDetail.cmp_telephonenumber.to_s.length.to_i >1) ? @compDetail.cmp_telephonenumber.to_s : '' )+((@compDetail.cmp_telephonenumber.to_s.length.to_i >1) ? ', ': '')+((@compDetail.cmp_cell_number.to_s.length.to_i >1) ? '+91 '+@compDetail.cmp_cell_number.to_s : ''), :align => :left, :size =>9
          move_down 5
          nutdats  = ''
          nfrdats  = ''
         if @from_date!='' && @from_date!=nil
            frdats  = Date.parse(@from_date.to_s)
            nfrdats = frdats.strftime('%d-%b-%Y')
          end
          if @upto_date!='' && @upto_date!=nil
            utdats  = Date.parse(@upto_date.to_s)
            nutdats = utdats.strftime('%d-%b-%Y')
          end
           text "<u>Issue Return Register</u>", :align => :center, :size =>11,:font_weight=>:bold,:inline_format=> TRUE
           move_down 2
           if @from_date!=nil && @from_date!='' && @upto_date!='' && @upto_date!=nil
            text "From Date : "+nfrdats.to_s+" Upto Date : "+nutdats.to_s, :align => :center, :size =>8
          elsif @from_date!=nil && @from_date!=''
            text "From Date : "+nfrdats.to_s, :align => :center, :size =>8
          elsif @upto_date!='' && @upto_date!=nil
            text "Upto Date : "+nutdats.to_s, :align => :center, :size =>8
          end
          
       end

     move_down 5
     table issue_line_items_rows,  :width=>650 do
      row(0).column(0..9).align        = :center
      row(1..5000).column(0).align     = :center
      row(1..5000).column(1..2).align  = :center
      row(1..5000).column(3..6).align  = :left
      row(1..5000).column(7).align     = :center
      row(1..5000).column(8..10).align = :right
      row(0..5000).column(0).width     = 30
      row(0..5000).column(1).width     = 40
      row(0..5000).column(2).width     = 70
      row(0..5000).column(3).width     = 60
      row(0..5000).column(4).width     = 60
      row(0..5000).column(5).width     = 60
      row(0..5000).column(6).width     = 190
      row(0..5000).column(7).width     = 40
      row(0..5000).column(8).width     = 50
      row(0..5000).column(9).width     = 50
      cells.size                       = 8
      cells.padding                    = 5
      cells.min_width                  = 300
      cells.border_width               = 1
      self.row_colors =["FFFFFF"]
      self.header =true
    end
   
 end

 def issue_line_items_rows
    [["Sl.No.","Doc. No","Doc. Date","Customer","Unit","Engineer","Item","Qty.","Rate","Amount"]]+
    @invoice.each.map do |inv|
       [count,inv.hd_billnumber.to_s,date_formats(inv.hd_billdate.to_s),(inv.cs_customername.to_s!=nil ? inv.cs_customername.to_s : ''),(inv.un_name.to_s!=nil ? inv.un_name.to_s : ''),(inv.emp_name.to_s!=nil ? inv.emp_name.to_s : ''),inv.dt_itemname.to_s,(inv.dt_quantity.to_i >0 ? inv.dt_quantity.to_s : ''),( inv.dt_rate.to_i >0 ? "%.2f" % inv.dt_rate.to_s : '' ),(inv.dt_netamount.to_f > 0 ? ("%.2f" % inv.dt_netamount.to_f).to_s : '' )]
    end +
      [[{:content=> "<b>Total</b>",:inline_format=> TRUE,:colspan=>7,:align=>:left,:size=>:bold},{:content=>"<b>"+@tqnty.to_s+"</b>",:colspan=>1,:inline_format=> TRUE,:align=>:center,:size=>:bold },{:content=> '',:colspan=>1,:align=>:right,:size=>:bold },{:content=>"<b>"+ ("%.2f" % @tnetamt.to_f).to_s+"</b>",:inline_format=> TRUE,:colspan=>1,:align=>:right,:size=>:bold }]]

  end


def date_formats(dates)
  if dates.to_s!=nil && dates.to_s!=''
    nrdate = Date.parse(dates.to_s)
    ndate  = nrdate.strftime('%d-%b-%Y')
    return ndate
  end
end

def count
  @count ||= 0
  @count = @count+1
end
def make_sum_of_all
    @tqnty    = 0
    @tdsamt   = 0
    @tigstamt = 0
    @tcgstamt = 0
    @tsgstamt = 0
    @tnetamt  = 0
    @dtvalues = 0
    @taxamt   = 0
    @invoice.each do |ts|
        @tqnty    = @tqnty+ts.dt_quantity
        @tdsamt   = @tdsamt+ts.dt_discountamount
        @tigstamt = @tigstamt+ts.dt_igstamount
        @tcgstamt = @tcgstamt+ts.dt_cgstamount
        @tsgstamt = @tsgstamt+ts.dt_sgstamount
        @tnetamt  = @tnetamt+ts.dt_netamount
        @dtvalues = @dtvalues+ts.dt_values
   end
   if @cstype != 'local'
     @taxamt = @tigstamt.to_f
   else
     @taxamt = @tcgstamt.to_f+@tsgstamt.to_f
   end
   
 end
 def number_currency_in_words
   to_words(@tnetamt.to_f)
   #NumbersInWords.in_words(@tnetamt.to_f).split(/ |\_|\-/).map(&:capitalize).join(" ")
 end

 def line_items_for_igst

        move_down 1
          if @compDetail.cmp_gstname.to_s.length >1
          pad(-1) { text "GST No. : "+@compDetail.cmp_gstname.to_s, :size => 9 }
          else
           pad(10) { text "" }
          end
          pad(150) { text "" }
          # header
          bounding_box [bounds.left, bounds.top], :width  => bounds.width do
          font "Helvetica"
          if @islud !='' && @islud!=nil
             text "<u>EXPORT INVOICE</u>", :align => :center, :size =>11,:font_weight=>:bold,:inline_format=> TRUE
          else
             text "<u>TAX INVOICE</u>", :align => :center, :size =>11,:font_weight=>:bold,:inline_format=> TRUE
          end
         
          if @compDetail.cmp_show_logo =='Y'
            if @compDetail.cmp_logos.to_s.length >1
               @filesExt = Rails.root.join "public", "images", "logo","thumb",@compDetail.cmp_logos.to_s
               if File.exist?(@filesExt)
                 image open(@uRl++"images/logo/thumb/"+@compDetail.cmp_logos.to_s),:scale => @logoSize,:position => :right,:vposition => :top
               else
                 pad(10) { text "" }
               end
            end
          else
           pad(10) { text "" }
          end
          text @compDetail.cmp_companyname.to_s.upcase, :align => :center, :size => 12
          text ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? @compDetail.cmp_addressline1.to_s: '' )+((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? ', ': '' )+@compDetail.cmp_addressline2.to_s : '')+((@compDetail.cmp_addressline3.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ', ': '' )+@compDetail.cmp_addressline3.to_s: ''), :align => :center, :size => 9
          text "Contact Details :"+((@compDetail.cmp_telephonenumber.to_s.length.to_i >1) ? @compDetail.cmp_telephonenumber.to_s : '' )+((@compDetail.cmp_telephonenumber.to_s.length.to_i >1) ? ', ': '')+((@compDetail.cmp_cell_number.to_s.length.to_i >1) ? '+91 '+@compDetail.cmp_cell_number.to_s : ''), :align => :center, :size =>9
          #stroke_horizontal_rule
          @cdate = ''
           if @invoice[0].hd_billdate.to_s!='' && @invoice[0].hd_billdate.to_s!=nil
             prasDate  = Date.parse(@invoice[0].hd_billdate.to_s)
             @cdate    = prasDate.strftime('%d-%b-%Y')
           end
         
         if @invoice[0].hd_refnumber.length >1
          data = [["Reverse Charge",": No"," ", "Reference No",": "+@invoice[0].hd_refnumber,"" ]]
         else
          data = [["Reverse Charge",": No"," ", "","","" ]]
         end
         if @invoice[0].hd_vehicaldtl.length >1
            data += [["Invoice No",": "+@invoice[0].hd_billnumber ," ","Invoice Date",": "+@cdate,""]]
         else
            data += [["Invoice No",": "+@invoice[0].hd_billnumber ," ","Invoice Date",": "+@cdate,""]]
         end
        if @invoice[0].hd_amcdate!=nil && @invoice[0].hd_amcdate!=''
          amcdt    = Date.parse(@invoice[0].hd_amcdate.to_s)
          namcdt   = amcdt.strftime('%d-%b-%Y')
          data += [["Invoice Date",": "+@cdate," ","AMC Date",": "+namcdt,""]]
        elsif @invoice[0].hd_driverdetail.length >1
          data += [["Vehicle No",": "+@invoice[0].hd_vehicaldtl," ","Driver Details",": "+@invoice[0].hd_driverdetail,""]]
        else
          #data += [["",""," ",""," ",""]]
        end

          data += [["State",": "+@loc.state_name,"State Code : "+@loc.tin_number,"Remarks",": "+@invoice[0].hd_remark]]
          table([] + data,:width=>540) do
          style row(0),  :size => 9,:border_width => 0
          style row(1),  :size => 9,:border_width => 0
          style row(2),  :size => 9,:border_width => 0
          style row(3),  :size => 9,:border_width => 0
         end      
         mkname  =   "<b>"+@invoice[0].cs_customername.to_s.split(/ |\_|\-/).map(&:capitalize).join(" ")+"</b>"
          if @shipto!=nil
            mkship  =   "<b>"+@shipto.cs_customername.to_s.split(/ |\_|\-/).map(&:capitalize).join(" ")+"</b>"
          end
          billto = "Name           "+": "+mkname.to_s+"\n Address       "+": "+@invoice[0].cs_billingaddress.to_s+((@invoice[0].cs_billingaddress1.to_s.length.to_i >1) ? ', ' : '')+@invoice[0].cs_billingaddress1.to_s+"\n GSTIN         "+": "+@invoice[0].cs_gstnumber.to_s+"\n State           "+": "+@loc.state_name.to_s+"\n State Code "+": "+@loc.tin_number.to_s
          if @shipto!=nil
           shipto = "Name          "+": "+mkship.to_s+"\n Address      "+": "+@shipto.cs_billingaddress.to_s+((@shipto.cs_billingaddress.to_s.length.to_i >1) ? ', ' : '')+@shipto.cs_billingaddress1.to_s+"\n GSTIN        "+": "+@shipto.cs_gstnumber.to_s+"\n State           "+": "+@shipto.state_name.to_s+"\n State Code "+": "+@shipto.tin_number.to_s
          else
           shipto = "Name:         "+": "+"\n Address      "+": "+"\n GSTIN:        "+": "+"\n State           "+": "+"\n State Code "+": "
          end
         data1 = [[{ :content=> "Details Of Receiver|Bill To :", :colspan=>3 }, { :content=> "Detail Of Consignee|Ship To :", :colspan=>3 }],
         [{:content =>billto , :rowspan => 2,:colspan=>3}, {:content => shipto, :rowspan => 2,:colspan=>3}]
         ]

          table([] + data1,:cell_style => {:inline_format => true },:width=>540) do
          style row(0),  :size => 8,:border_style => :right,:align=>:center
          style row(1),  :size => 8,:border_style => :right,:align=>:left
          end
       
       end

    move_down 2
     table line_item_rows,  :width=>540 do
      #row(0).font_style = :bold
      row(0).column(1..9).align        = :center
      row(0..5000).column(0).width     = 30
      row(0..5000).column(3).width     = 80
      row(0..5000).column(4).width     = 45
      row(0..5000).column(5).width     = 50
      row(0..5000).column(6).width     = 60
      row(0..5000).column(7).width     = 45
      row(0..5000).column(8).width     = 55
      row(0..5000).column(9).width     = 55
      #row(0..5000).column(10).width    = 80
      row(1..5000).column(4).align     = :right
      row(1..5000).column(5).align     = :center
      row(1..5000).column(5..10).align = :right      
      cells.size = 7
      cells.padding = 5
      cells.min_width = 250
      cells.border_width = 1
      self.row_colors =["FFFFFF"]
      self.header =true
    end
  
     data3   = [
               [{:content =>"Bank Details" , :rowspan => 2,:colspan=>2}, {:content => "", :rowspan => 2,:colspan=>4}],
              ]
         if  @isTakeTax == 'Y'    
            table([] + data3,:width=>540) do
              row(0).column(0).width=217
              row(0).column(1).width=17
              row(0).column(2).width=26
              row(0).column(4).width=32
              row(0).column(3).width=71
              row(0).column(5).width=38
              row(0).column(4).font_style= :bold
              row(0).column(4).align = :left
              row(0).column(6).align = :right
              row(0).column(0).font_style= :bold
              row(0).column(0).align = :center
              cells.size = 6
            end
         else
           table([] + data3,:width=>540) do
              row(0).column(0).width=264
              row(0).column(1).width=17
              row(0).column(2).width=26
              row(0).column(4).width=32
              row(0).column(3).width=71
              row(0).column(5).width=38
              row(0).column(4).font_style= :bold
              row(0).column(4).align = :left
              row(0).column(6).align = :right
              row(0).column(0).font_style= :bold
              row(0).column(0).align = :center
              cells.size = 6
            end
         end
         bankdetail = "Bank Name                   "+": "+@compDetail.cmp_bankname.to_s.split(/ |\_|\-/).map(&:capitalize).join(" ")+"\nBank Branch                 "+": "+@compDetail.cmp_bankbranch.to_s.split(/ |\_|\-/).map(&:capitalize).join(" ")+"\nBank Account Number "+": "+@compDetail.cmp_accountnumber.to_s+"\nBank Branch IFSC       "+": "+@compDetail.cmp_bankifsccode.to_s+"\n\n .          "+terms_and_conditions.to_s+"    .\n\n"+@compDetail.cmp_termandcondition.to_s
         gstLable   ="For, "+@compDetail.cmp_companyname.to_s.upcase+"\n\n\n\n\n"+"Authorized Signatory"
   
      data4   = [
               [{:content =>bankdetail , :rowspan => 2,:colspan=>2}, {:content =>gstLable , :rowspan => 2,:colspan=>3}],
              ]
         if  @isTakeTax == 'Y'
          table([] + data4,:width=>540) do
            row(0).column(0).width=161
            row(0).column(1).width=18
            row(0).column(2).width=27
            row(0).column(4).width=32
            row(0).column(3).width=44
            row(0).column(5).width=38
            row(0).column(4).font_style= :bold
            row(0).column(4).align = :left
            row(0).column(6).align = :right
            row(0).column(2).align = :right
            row(0).column(0).font_style= :normal
            row(0).column(0).align = :left
            cells.size = 7
          end
         else
           table([] + data4,:width=>540) do
            row(0).column(0).width=217
            row(0).column(1).width=18
            row(0).column(2).width=27
            row(0).column(4).width=32
            row(0).column(3).width=44
            row(0).column(5).width=38
            row(0).column(4).font_style= :bold
            row(0).column(4).align = :left
            row(0).column(6).align = :right
            row(0).column(2).align = :right
            row(0).column(0).font_style= :normal
            row(0).column(0).align = :left
            cells.size = 7
          end  
         end
         pad(2){text  "E&O.E" ,:align=>:right,:size=>7}
        
 end





def to_words(num)
  numbers_to_name = {
      10000000 => "Crore",
      100000 => "Lakh",
      1000 => "Thousand",
      100 => "Hundred",
      90 => "Ninety",
      80 => "Eighty",
      70 => "Seventy",
      60 => "Sixty",
      50 => "Fifty",
      40 => "Forty",
      30 => "Thirty",
      20 => "Twenty",
      19=>"Nineteen",
      18=>"Eighteen",
      17=>"Seventeen",
      16=>"Sixteen",
      15=>"Fifteen",
      14=>"Fourteen",
      13=>"Thirteen",
      12=>"Twelve",
      11 => "Eleven",
      10 => "Ten",
      9 => "Nine",
      8 => "Eight",
      7 => "Seven",
      6 => "Six",
      5 => "Five",
      4 => "Four",
      3 => "Three",
      2 => "Two",
      1 => "One"
    }

  log_floors_to_ten_powers = {
    0 => 1,
    1 => 10,
    2 => 100,
    3 => 1000,
    4 => 1000,
    5 => 100000,
    6 => 100000,
    7 => 10000000
  }

  num = num.to_i
  return '' if num <= 0 or num >= 100000000

  log_floor = Math.log(num, 10).floor
  ten_power = log_floors_to_ten_powers[log_floor]

  if num <= 20
    numbers_to_name[num]
  elsif log_floor == 1
    rem = num % 10
    [ numbers_to_name[num - rem], to_words(rem) ].join(' ')
  else
    [ to_words(num / ten_power), numbers_to_name[ten_power], to_words(num % ten_power) ].join(' ')
  end
end
end
