# To change this template, choose Tools | Templates
# and open the template in the editor.

class BillsummaryPdf < Prawn::Document
  def initialize(report,loc,shipto,compDetail,cstype,uRl,isProforma,isTakeTax,gprams,opbal,clbal,lastPayment,isrndamt)
    super(:margin_top=>20,:page_size =>"A4")
    @invoice    = report
    @loc        = loc
    @shipto     = shipto
    @compDetail = compDetail
    @cstype     = cstype
    @uRl2       = uRl
    @uRl        = Rails.root.join "public"
    @logoSize   = 0.5
    @isProforma = isProforma
    @isTakeTax  = isTakeTax
    @from_date  = gprams[:from_date].to_s
    @upto_date  = gprams[:upto_date].to_s
    @isSaleType = gprams[:issaletype].to_s
    @from_item  = gprams[:from_item].to_s
    @upto_item  = gprams[:upto_item].to_s
    @show_add   = gprams[:comp_show_add].to_s
    @isbilltype = gprams[:is_bill_tp].to_s
    @customer   = shipto!='' ? shipto.cs_customername.to_s : ''
    @cellnumber = shipto!='' ? shipto.cs_mobilenumber.to_s : ''
    @phnumber   = shipto!='' ? shipto.cs_telephonenumbers.to_s : ''
    @emaladd    = shipto!='' ? shipto.cs_emailaddress.to_s : ''
    @opbal      = opbal
    @clbal      = clbal
    @isgodaam   =  (@compDetail.cmp_godam_allowed=='Y' ) ? true : false
    @isrndamt   =  ( isrndamt!='' && isrndamt =='Y' ) ? true : false
    if lastPayment!=nil
      @lastPayment = lastPayment.pr_netamount!='' ? '%.2f' % lastPayment.pr_netamount : ''
      @lastPmtDate = lastPayment.pr_date!='' ? lastPayment.pr_date : ''
    else
     @lastPayment = ''
     @lastPmtDate = ''
    end
    make_sum_of_all
    invoice_items
    line_items
 end

 def invoice_items
    #text "GST : TAV37629121N"
  end
  def terms_and_conditions
       "Terms and Conditions"
  end
  def count_mcell
  @count_cell ||= 0
  @count_cell = @count_cell+1
end
  def line_items
        move_down 2
          pad(-1) {
           if @compDetail.cmp_show_logo =='Y'
              if @compDetail.cmp_logos.to_s.length >1
                npath = Rails.root.join "public",'images','logo','thumb'
               if File.exists?("#{npath}/"+@compDetail.cmp_logos.to_s)
                 image open(@uRl+"images/logo/thumb/"+@compDetail.cmp_logos.to_s),:scale => @logoSize,:position => :right,:vposition => :top
               end
              end
           end 
          }
          move_down 15
          # header
          nfrdats =''
          bounding_box [bounds.left, bounds.top], :width  => bounds.width do
          font "Helvetica"
          if @show_add!=nil && @show_add!='' && @show_add =='Y'
              if @compDetail.cmp_companyname.to_s!=nil && @compDetail.cmp_companyname.to_s!=''
              text @compDetail.cmp_companyname.to_s.upcase, :align => :left, :size => 10,:vposition => :top
              end
              if @compDetail.cmp_addressline1.to_s!=nil && @compDetail.cmp_addressline1.to_s!=''
              text ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? @compDetail.cmp_addressline1.to_s.capitalize: '' )+((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? ', ': '' )+@compDetail.cmp_addressline2.to_s.capitalize : '')+((@compDetail.cmp_addressline3.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ', ': '' )+@compDetail.cmp_addressline3.to_s.capitalize: ''), :align => :left, :size => 9,:vposition => :top
              end
              if @compDetail.cmp_telephonenumber.to_s!=nil && @compDetail.cmp_telephonenumber.to_s!=''
              text @compDetail.cmp_telephonenumber.to_s+((@compDetail.cmp_telephonenumber.to_s.length.to_i >1) ? ', +91 ': '')+@compDetail.cmp_cell_number.to_s, :align => :left, :size =>9,:vposition => :top
              end
          end
          if @from_date!='' && @from_date!=nil
            frdats  = Date.parse(@from_date.to_s)
            nfrdats = frdats.strftime('%d-%b-%Y')
          end
          if @upto_date!='' && @upto_date!=nil
            utdats  = Date.parse(@upto_date.to_s)
            nutdats = utdats.strftime('%d-%b-%Y')
          end          
          if @isbilltype =='S'
             text "Bill Summary", :align => :center, :size =>10
          elsif @isbilltype =='SR'
             text "Bill Return Summary", :align => :center, :size =>10
          elsif @isbilltype =='P'
             text "Purchase Summary", :align => :center, :size =>10
          elsif @isbilltype =='PR'
             text "Purchase Return Summary", :align => :center, :size =>10
          end
          
          if @from_date!=nil && @from_date!='' && @upto_date!='' && @upto_date!=nil
            text "From Date : "+nfrdats.to_s+" Upto Date : "+nutdats.to_s, :align => :center, :size =>8
          elsif @from_date!=nil && @from_date!=''
            text "From Date : "+nfrdats.to_s, :align => :center, :size =>8
          elsif @upto_date!='' && @upto_date!=nil
            text "Upto Date : "+nutdats.to_s, :align => :center, :size =>8
          end      
           
          
       end

    move_down 20
     if @invoice.length >0
          #if @invoice[0].balanceamt.to_s.length >1
              table line_item_rows,  :width=>525 do
              row(0).column(1..7).align = :center
              row(0).column(1).width=30
              row(0).column(2).width=20
              row(0).column(4).width=60
              row(0).column(6).width=30
              #row(0).column(10).width=35
              row(1..5000).column(1..4).align = :center
              row(1..5000).column(5..8).align = :right
              cells.size = 7
              cells.padding = 5
              cells.min_width = 300
              cells.border_width = 1
              self.row_colors =["FFFFFF"]
              self.header =true
            end
        #end
    end
    
 end

 def line_item_rows
    if @isrndamt
      [["Sl.No.","Bill No","Bill Date","Customer","Phone","Total Value","Total Disc.","Total Tax","Net. Amt"]]+
        @invoice.each.map do |inv|
         [count,(inv.dt_billnumber.to_s!=nil ? inv.dt_billnumber.to_s : ''),date_formats(inv.hd_billdate.to_s),(inv.cs_customername.to_s!=nil ? inv.cs_customername.to_s : ''),(inv.cs_mobilenumber.to_s!=nil ? inv.cs_mobilenumber.to_s : ''),(inv.balanceamt.to_s!=nil ? ( "%.2f" % inv.balanceamt.to_f ).to_s : ''),(inv.dt_discountamount.to_s!=nil ? ("%.2f" % inv.dt_discountamount.to_f ).to_s : ''),(inv.debitsamt.to_s!=nil ? ("%.2f" % inv.debitsamt.to_f).to_s : ''),(inv.dt_netamount.to_s!=nil ? ("%.2f" % inv.dt_netamount.to_f).to_s : '')]
        end +
         [[{:content=> "Total",:colspan=>5,:align=>:right,:size=>:bold },{:content=> ("%.2f" % @dtvalues.to_f).to_s,:colspan=>1,:align=>:right,:size=>:bold },{:content=> ("%.2f" % @tdsamt.to_f).to_s,:colspan=>1,:align=>:right,:size=>:bold },{:content=> ("%.2f" % @taxes.to_f).to_s,:colspan=>1,:align=>:right,:size=>:bold },{:content=> (@tnetamt.to_f.ceil).to_s,:colspan=>1,:align=>:right,:size=>:bold }]]
   else
         [["Sl.No.","Bill No","Bill Date","Customer","Phone","Total Value","Total Disc.","Total Tax","Net. Amt"]]+
        @invoice.each.map do |inv|
         [count,(inv.dt_billnumber.to_s!=nil ? inv.dt_billnumber.to_s : ''),date_formats(inv.hd_billdate.to_s),(inv.cs_customername.to_s!=nil ? inv.cs_customername.to_s : ''),(inv.cs_mobilenumber.to_s!=nil ? inv.cs_mobilenumber.to_s : ''),(inv.balanceamt.to_s!=nil ? ( "%.2f" % inv.balanceamt.to_f ).to_s : ''),(inv.dt_discountamount.to_s!=nil ? ("%.2f" % inv.dt_discountamount.to_f ).to_s : ''),(inv.debitsamt.to_s!=nil ? ("%.2f" % inv.debitsamt.to_f).to_s : ''),(inv.dt_netamount.to_s!=nil ? ("%.2f" % inv.dt_netamount.to_f).to_s : '')]
        end +
         [[{:content=> "Total",:colspan=>5,:align=>:right,:size=>:bold },{:content=> ("%.2f" % @dtvalues.to_f).to_s,:colspan=>1,:align=>:right,:size=>:bold },{:content=> ("%.2f" % @tdsamt.to_f).to_s,:colspan=>1,:align=>:right,:size=>:bold },{:content=> ("%.2f" % @taxes.to_f).to_s,:colspan=>1,:align=>:right,:size=>:bold },{:content=> ("%.2f" % @tnetamt.to_f).to_s,:colspan=>1,:align=>:right,:size=>:bold }]]
   end
  

end

def count
  @count ||= 0
  @count = @count+1
end
def make_sum_of_all
    @tqnty    = 0
    @tdsamt   = 0
    @tigstamt = 0
    @tcgstamt = 0
    @tsgstamt = 0
    @tnetamt  = 0
    @dtvalues = 0
    @taxes = 0
    @invoice.each do |ts|
       # @tqnty    = @tqnty+ts.dt_quantity.to
        @tdsamt   = @tdsamt+ts.dt_discountamount
        @tigstamt = @tigstamt+ts.dt_igstamount
        @tcgstamt = @tcgstamt+ts.dt_cgstamount
        @tsgstamt = @tsgstamt+ts.dt_sgstamount
        @tnetamt  = @tnetamt+ts.dt_netamount
        @dtvalues = @dtvalues+ts.balanceamt
        @taxes    = @taxes+ts.debitsamt
   end
   
 end
 def number_currency_in_words
   NumbersInWords.in_words(@tnetamt.to_f).split(/ |\_|\-/).map(&:capitalize).join(" ")
 end
def date_formats(dates)
  if dates.to_s!=nil && dates.to_s!=''
    nrdate = Date.parse(dates.to_s)
    ndate  = nrdate.strftime('%d-%b-%Y')
  end
end
end
