# To change this template, choose Tools | Templates
# and open the template in the editor.

class DailyplanningPdf < Prawn::Document
  def initialize(report,loc,header,compDetail,cstype,uRl,isProforma,isTakeTax,gprams,isrndamt)
    super(:margin_top=>20,:page_size => [900, 900],:page_layout => :landscape)
    @invoice    = report
    @loc        = loc
    @header     = header
    @compDetail = compDetail
    @cstype     = cstype
    @uRl2       = uRl
    @uRl        = Rails.root.join "public"
    @logoSize   = 0.5   
    @isProforma = isProforma
    @isTakeTax  = isTakeTax
    @gprams     = gprams
    @isrndamt   = isrndamt
    @username   = @gprams[:autherizedUserName]
    #make_sum_of_all
    line_items
 end

def count_mcell
  @count_cell ||= 0
  @count_cell = @count_cell+1
end

 def line_items
        move_down 2
         pad(-1) {
           if @compDetail.cmp_show_logo =='Y'
            if @compDetail.cmp_logos.to_s.length >1
               @filesExt = Rails.root.join "public", "images", "logo","thumb",@compDetail.cmp_logos.to_s
               if File.exist?(@filesExt)
                image open(@uRl+"images/logo/thumb/"+@compDetail.cmp_logos.to_s),:scale => @logoSize,:position => :right,:vposition => :top
               else
                 pad(10) { text "" }
               end
            end
          else
           pad(10) { text "" }
          end
          }
          # header
         
          bounding_box [bounds.left, bounds.top], :width  => bounds.width do
          font "Helvetica"          
          text "<b>DAILY PLANNING SHEET", :align => :center, :size =>12,:inline_format=> TRUE
          move_down 5
          if @header
            text "<b>DOC NO : PRD/FM/"+@header.dpl_doc_no.to_s, :align => :right, :size =>12,:inline_format=> TRUE
          end
          move_down 10
          if @compDetail.cmp_companyname.to_s!=nil && @compDetail.cmp_companyname.to_s!=''
          text "<b>"+@compDetail.cmp_companyname.to_s+"</b>", :align => :left, :size => 11,:vposition => :top,:inline_format=> TRUE
          end
          if @compDetail.cmp_addressline1.to_s!=nil && @compDetail.cmp_addressline1.to_s!=''
          text ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? @compDetail.cmp_addressline1.to_s: '' )+((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? ' ': '' )+@compDetail.cmp_addressline2.to_s : '')+((@compDetail.cmp_addressline3.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ' ': '' )+"\n"+@compDetail.cmp_addressline3.to_s: ''), :align => :left, :size => 9,:vposition => :top
          end
          if @compDetail.cmp_telephonenumber.to_s!=nil && @compDetail.cmp_telephonenumber.to_s!=''
          text @compDetail.cmp_telephonenumber.to_s+((@compDetail.cmp_telephonenumber.to_s.length.to_i >1) ? ', +91 ': '')+@compDetail.cmp_cell_number.to_s, :align => :left, :size =>9,:vposition => :top
          end
          stroke_horizontal_rule
          move_down 10
          data = []
         @cdate = ''
         if @header.dpl_date.to_s!='' && @header.dpl_date.to_s!=nil
           prasdate  = Date.parse(@header.dpl_date.to_s)
           @cdate    = prasdate.strftime('%d-%b-%Y')
         end
         if @header.dpl_shift.to_s.length >1
            data += [["Sch. Date",": "+@cdate.to_s," ", "Shift",": "+@header.dpl_shift_detail.to_s,"" ]]
         end
         
         table([] + data,:width=>630) do
          style row(0),  :size => 9,:border_width => 0,:padding=>1
          style row(1),  :size => 9,:border_width => 0,:padding=>1
          style row(2),  :size => 9,:border_width => 0,:padding=>1
          style row(3),  :size => 9,:border_width => 0,:padding=>1
         end
        
       end
    lngth = @invoice.length;
    move_down 10    
    table line_item_rows, :cell_style => {:inline_format => true }, :width=>850 do
      row(0).column(1..14).align = :center
      row(0).column(0).width=30
      row(0).column(1).width=50
      row(0).column(2).width=50
      row(0).column(3).width=50
      row(0).column(4).width=40
      row(0).column(5).width=50
      row(0).column(6).width=40
      row(0).column(7).width=50
      row(0).column(8).width=70
      row(0).column(9).width=60
      row(0).column(10).width=50
      row(0).column(11).width=50
      row(0).column(12).width=50
      row(0).column(13).width=50
      row(0).column(14).width=40
      row(0).column(15).width=40
      row(0).column(16).width=40
      row(0).column(17).width=40
      row(1..5000).column(2).align = :right
      row(1..5000).column(6).align = :right
      row(1..5000).column(4).align = :right
      row(1..5000).column(12..16).align = :right
      cells.size = 7
      cells.padding = 5
      cells.min_width = 300
      cells.border_width = 1
      self.row_colors =["FFFFFF"]
      self.header =true
    end
      
   
 end

 def line_item_rows
     [["SlNo.","Code1","Qty.","Code2","Qty","Code3","Qty","MQNBNO","Customer\nName","Worker\nName","CatNo","Material","Issue","Qty","WT","CT","PT","Stamp"]]+
    @invoice.each.map do |inv|
     [count,(inv.dpld_codename1.to_s!=nil ? inv.dpld_codename1.to_s : ''),common_formatted(inv.dpld_qty1).to_s,inv.dpld_codename2.to_s,(inv.dpld_qty2.to_s!='' ? common_formatted(inv.dpld_qty2).to_s : ''),inv.dpld_codename3,common_formatted(inv.dpld_qty3),inv.dpld_mqnb,inv.dpld_customer,inv.dpld_worker,inv.dpld_itemname,inv.dpld_material,common_formatted(inv.dpld_issue),common_formatted(inv.dpld_qty),common_formatted(inv.dpld_wt),common_formatted(inv.dpld_curing),common_formatted(inv.dpld_processing),inv.dpld_stamp]
    end 
end

def count
  @count ||= 0
  @count = @count+1
end
def make_sum_of_all
    @tqnty    = 0
    @tstok    = 0
    @tact     = 0
   
    @invoice.each do |ts|
        @tqnty    = @tqnty+ts.rqd_requisition_qty.to_i
        @tstok    = @tstok+ts.rqd_stock_qty.to_i
        @tact     = @tact+ts.rqd_actual_qty.to_i
        
   end
 end
 def number_currency_in_words
   NumbersInWords.in_words(@tnetamt.to_f).split(/ |\_|\-/).map(&:capitalize).join(" ")
 end
def date_formats(dates)
  ndate = ''
  if dates.to_s!=nil && dates.to_s!=''
    nrdate = Date.parse(dates.to_s)
    ndate  = nrdate.strftime('%d-%b-%Y')
  end
  return ndate
end
private
   def common_formatted(amt)
        amts = ''
        if amt!=nil && amt!=''
          amts = "%.2f" % amt.to_f
        end
        return amts
   end
end
